package edu.stanford.hci.dtools.io.make;

import java.io.IOException;
import java.util.TimerTask;

import com.illposed.osc.OSCMessage;
import com.illposed.osc.OSCPortOut;

/**
 * Poll a make controller via OSC over UDP for all its analog input values 
 * @author bjoern
 *
 */
public class MakeControllerPollAnalogInTask extends TimerTask {

	final OSCPortOut out;
	final OSCMessage msg;
	
	public MakeControllerPollAnalogInTask(OSCPortOut out) {
		super();
		this.out = out;
		msg = new OSCMessage("/analogin/*/value");
	}

	@Override
	public void run() {
		//poll
		try {
			out.send(msg);
		} catch (IOException e) {
			System.err.println("Caught IO Exception while trying to poll Make Controller.");
			e.printStackTrace();
		}
	}

}


