package edu.stanford.hci.exemplar;

import java.util.TimerTask;
/**
 * Exemplar
 * Copyright (c) 2004-2007, Stanford University
 * All rights reserved.
 *
 * <p>
 * This software is distributed under the <a href="http://hci.stanford.edu/research/copyright.txt">
 * BSD License</a>.
 * </p>
 * 
 * 
 * @author <a href="http://bjoern.org/">Bjoern Hartmann</a> ( bjoern(AT)stanford.edu )
 * @author Leith Abdulla
 */
public class RedrawDataTask extends TimerTask {
	boolean run=true;
	
	public void pause() {
		run=false;
	}
	public void resume() {
		run=true;
	}
	@Override
	public void run() {
		if(run) {
		//	fire a prop change that causes every live data view to redraw;
			Activator.getDefault().pcs.firePropertyChange(ExemplarConstants.PROP_REDRAW, null, null);
		}
	}
	public boolean isPaused() {
		return !run;
	}
	public void setPaused(boolean paused) {
		run = !paused;
		
	}

}
