package edu.stanford.hci.exemplar;
/**
 * Exemplar
 * Copyright (c) 2004-2007, Stanford University
 * All rights reserved.
 *
 * <p>
 * This software is distributed under the <a href="http://hci.stanford.edu/research/copyright.txt">
 * BSD License</a>.
 * </p>
 * 
 * 
 * @author <a href="http://bjoern.org/">Bjoern Hartmann</a> ( bjoern(AT)stanford.edu )
 * @author Leith Abdulla
 */
public class SmootheFilter {
	private Float area = 0.f;
	private Integer width = 0;
	private Double  root = 0.d;
	private Float sd = 0.f;
	
	SmootheFilter() {
		// Constructor
	}
	
	SmootheFilter(Integer width, Float sd) {
		init(width,sd);
	}
	
	public void init(Integer width, Float sd) {
		area = 0.f;
		this.width = width;
		this.sd = sd;
		root = (1/(Math.sqrt(2.d * Math.PI * sd)));
		for(int i = 0; i< width; i++) {
			area += gauss(i).floatValue();
		}
	}
		
	public Double gauss(Integer i) {
		return (Math.exp((-1)*i*i / (2*sd*sd)));
	}

	public Float getArea() {
		return area;
	}
}