package edu.stanford.hci.exemplar.actions;



import java.util.List;

import org.eclipse.jface.action.IAction;
import org.eclipse.jface.viewers.ISelection;
import org.eclipse.swt.SWT;
import org.eclipse.ui.IWorkbenchWindow;
import org.eclipse.ui.IWorkbenchWindowActionDelegate;

import edu.stanford.hci.exemplar.Activator;
import edu.stanford.hci.exemplar.Event;
import edu.stanford.hci.exemplar.Sensor;
import edu.stanford.hci.exemplar.widgets.SelectOneEventDialog;
/**
 * Exemplar
 * Copyright (c) 2004-2007, Stanford University
 * All rights reserved.
 *
 * <p>
 * This software is distributed under the <a href="http://hci.stanford.edu/research/copyright.txt">
 * BSD License</a>.
 * </p>
 * 
 * 
 * @author <a href="http://bjoern.org/">Bjoern Hartmann</a> ( bjoern(AT)stanford.edu )
 * @author Leith Abdulla
 */
public class ExportPseudocodeAction implements IWorkbenchWindowActionDelegate {
	private IWorkbenchWindow window;
	public void dispose() {
		// TODO Auto-generated method stub

	}

	public void init(IWorkbenchWindow window) {
		this.window=window;

	}

	public void run(IAction action) {
		SelectOneEventDialog dialog = new SelectOneEventDialog(window.getShell(),SWT.OPEN);
		Event e = dialog.open();
		
		if(e!=null) {
			String code ="";
			code += e.getPseudocode();
			List<String> addresses = e.getEventSet().getOscAddresses();
			for(String address:addresses) {
				Sensor sensor = Activator.getDefault().getSensorForOscAddress(address);
				code+=sensor.getPseudocode();
			}
			
		}

	}

	public void selectionChanged(IAction action, ISelection selection) {
		// TODO Auto-generated method stub

	}

}
