package edu.stanford.hci.exemplar.actions;

import org.eclipse.jface.action.IAction;
import org.eclipse.jface.viewers.ISelection;
import org.eclipse.swt.SWT;
import org.eclipse.ui.IWorkbenchWindow;
import org.eclipse.ui.IWorkbenchWindowActionDelegate;

import edu.stanford.hci.exemplar.Activator;
import edu.stanford.hci.exemplar.widgets.SafeSaveDialog;
import edu.stanford.hci.exemplar.widgets.SelectOneOscAddressDialog;
/**
 * Exemplar
 * Copyright (c) 2004-2007, Stanford University
 * All rights reserved.
 *
 * <p>
 * This software is distributed under the <a href="http://hci.stanford.edu/research/copyright.txt">
 * BSD License</a>.
 * </p>
 * 
 * 
 * @author <a href="http://bjoern.org/">Bjoern Hartmann</a> ( bjoern(AT)stanford.edu )
 * @author Leith Abdulla
 */
public class SaveRawDataAction implements IWorkbenchWindowActionDelegate {
	private IWorkbenchWindow window;
	public void dispose() {
		// TODO Auto-generated method stub

	}

	public void init(IWorkbenchWindow window) {
		this.window=window;

	}

	public void run(IAction action) {
		
		SelectOneOscAddressDialog sdialog = new SelectOneOscAddressDialog(window.getShell(),SWT.OPEN);

		String sensor = sdialog.open();
		
		if(sensor!=null) {
			SafeSaveDialog dialog = new SafeSaveDialog (window.getShell());
			dialog.setFilterNames (new String [] {"Exemplar Raw Files", "All Files (*.*)"});
			dialog.setFilterExtensions (new String [] {"*.erw", "*.*"}); //Windows wild cards
			dialog.setFilterPath ("c:\\"); //Windows path
			dialog.setFileName ("exemplar-sensor-data.erw");
			String filename = dialog.open();
			//execute the save
			if(filename!=null)
				Activator.getDefault().saveRawSensorDataToFile(sensor,filename);
		}
			
		
	}

	public void selectionChanged(IAction action, ISelection selection) {
		// TODO Auto-generated method stub

	}

}
