package edu.stanford.hci.exemplar.flashserver;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.net.Socket;
import java.util.ArrayList;
import java.util.List;

import edu.stanford.hci.exemplar.Event;
/**
 * Exemplar
 * Copyright (c) 2004-2007, Stanford University
 * All rights reserved.
 *
 * <p>
 * This software is distributed under the <a href="http://hci.stanford.edu/research/copyright.txt">
 * BSD License</a>.
 * </p>
 * 
 * 
 * @author <a href="http://bjoern.org/">Bjoern Hartmann</a> ( bjoern(AT)stanford.edu )
 * @author Leith Abdulla
 */
public class FlashListener implements Runnable {
	
	Socket clientSocket;
	FlashServer server;
	BufferedReader in;
	List<Event> createdEvents = new ArrayList<Event>();

	public FlashListener(Socket clientSocket, FlashServer server) {
		this.clientSocket=clientSocket;
		this.server=server;
		
	}

	public void run() {
		//create the input reader
		try {
			in = new BufferedReader(
                new InputStreamReader(
                    clientSocket.getInputStream()));
		} catch (Exception e) {
			System.err.println("FlashListener: Could not created InputStreamReader");
		}
		String inputLine;
		try {
			char charBuffer[] = new char[1];
			while(in.read(charBuffer,0,1) != -1) {
				//--- create a string buffer to hold the incoming stream
                StringBuffer stringBuffer = new StringBuffer(8192);
            
                // --- while the stream hasn't ended
                while(charBuffer[0] != '\0') {
                    // --- add the character to our buffer
                    stringBuffer.append(charBuffer[0]);
                    in.read(charBuffer, 0 ,1);
                }
                inputLine = stringBuffer.toString();
				System.out.println("FlashListener: Received "+inputLine);
				
				//hacked pseudo parser
				inputLine = inputLine.replaceAll("\000", "");
				//INSERT INPUT HANDLER HERE
			}
			
		} catch (IOException e) {
			e.printStackTrace();
		}
		try {
			System.out.println("Closing FlashListener.");
			clientSocket.close();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}
	
}
