package edu.stanford.hci.exemplar.output;

import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;

import edu.stanford.hci.exemplar.Activator;
import edu.stanford.hci.exemplar.ExemplarConstants;
import edu.stanford.hci.exemplar.flashserver.FlashServer;
/**
 * Exemplar
 * Copyright (c) 2004-2007, Stanford University
 * All rights reserved.
 *
 * <p>
 * This software is distributed under the <a href="http://hci.stanford.edu/research/copyright.txt">
 * BSD License</a>.
 * </p>
 * 
 * 
 * @author <a href="http://bjoern.org/">Bjoern Hartmann</a> ( bjoern(AT)stanford.edu )
 * @author Leith Abdulla
 */
public class FlashOutput implements PropertyChangeListener {

	private boolean active=true;
	private static FlashOutput uniqueInstance;
	
	
	public FlashOutput() {
		super();
		uniqueInstance=this;
		Activator.getDefault().pcs.addPropertyChangeListener(ExemplarConstants.PROP_EVENT_ON, this);
		Activator.getDefault().pcs.addPropertyChangeListener(ExemplarConstants.PROP_EVENT_OFF, this);
		Activator.getDefault().pcs.addPropertyChangeListener(ExemplarConstants.PROP_NEW_FILTERED_DATA, this);
	}
	public static FlashOutput instance() {
		return uniqueInstance;
	}
	public void propertyChange(PropertyChangeEvent evt) {
		//eventname is in evt.getNewValue();
		//on/off is in evt.getPropertyName();
		
		//don't send anything if we're not active.
		if(!active)
			return;
		
		//TODO: don't send if our event is not active
		
		String status="";
		if(ExemplarConstants.PROP_EVENT_ON.equals(evt.getPropertyName())) {
			status="1";
		} else if(ExemplarConstants.PROP_EVENT_OFF.equals(evt.getPropertyName())){
			status="0";
		}else  if(ExemplarConstants.PROP_NEW_FILTERED_DATA.equals(evt.getPropertyName())) {
			status = ((Integer)evt.getOldValue()).toString();
		}
		String msg = "<exemplarevent address=\""+(String)evt.getNewValue()+"\" value=\""+status+"\" />";
		FlashServer.instance().sendMessageToFlash(msg);	
	
		
	}
	public boolean isActive() {
		return active;
	}

	public void setActive(boolean active) {
		this.active = active;
	}
	
	
}
