package edu.stanford.hci.exemplar.widgets;

import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.eclipse.swt.SWT;
import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.graphics.Rectangle;
import org.eclipse.swt.layout.FillLayout;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Control;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.ExpandItem;
import org.eclipse.swt.widgets.Group;
import org.eclipse.swt.widgets.Shell;

import edu.stanford.hci.exemplar.Activator;
import edu.stanford.hci.exemplar.ExemplarConstants;


/**
* This code was edited or generated using CloudGarden's Jigloo
* SWT/Swing GUI Builder, which is free for non-commercial
* use. If Jigloo is being used commercially (ie, by a corporation,
* company or business for any purpose whatever) then you
* should purchase a license for each developer using Jigloo.
* Please visit www.cloudgarden.com for details.
* Use of Jigloo implies acceptance of these licensing terms.
* A COMMERCIAL LICENSE HAS NOT BEEN PURCHASED FOR
* THIS MACHINE, SO JIGLOO OR THIS CODE CANNOT BE USED
* LEGALLY FOR ANY CORPORATE OR COMMERCIAL PURPOSE.
*/
/**
 * Exemplar
 * Copyright (c) 2004-2007, Stanford University
 * All rights reserved.
 *
 * <p>
 * This software is distributed under the <a href="http://hci.stanford.edu/research/copyright.txt">
 * BSD License</a>.
 * </p>
 * 
 * 
 * @author <a href="http://bjoern.org/">Bjoern Hartmann</a> ( bjoern(AT)stanford.edu )
 * @author Leith Abdulla
 */
public class EventSetContainer extends org.eclipse.swt.widgets.Composite implements PropertyChangeListener{

	private final Map <List<String>,Control> map = new HashMap<List<String>,Control>();
	GridData showLayoutData;
	GridData hideLayoutData;
	/**
	* Auto-generated main method to display this 
	* org.eclipse.swt.widgets.Composite inside a new Shell.
	*/
	public static void main(String[] args) {
		showGUI();
	}
		
	/**
	* Auto-generated method to display this 
	* org.eclipse.swt.widgets.Composite inside a new Shell.
	*/
	public static void showGUI() {
		Display display = Display.getDefault();
		Shell shell = new Shell(display);
		EventSetContainer inst = new EventSetContainer(shell, SWT.NULL);
		Point size = inst.getSize();
		shell.setLayout(new FillLayout());
		shell.layout();
		if(size.x == 0 && size.y == 0) {
			inst.pack();
			shell.pack();
		} else {
			Rectangle shellBounds = shell.computeTrim(0, 0, size.x, size.y);
			shell.setSize(shellBounds.width, shellBounds.height);
		}
		shell.open();
		while (!shell.isDisposed()) {
			if (!display.readAndDispatch())
				display.sleep();
		}
	}

	public EventSetContainer(org.eclipse.swt.widgets.Composite parent, int style) {
		super(parent, style);
		initGUI();
		if(Activator.getDefault()!=null)
			Activator.getDefault().pcs.addPropertyChangeListener(ExemplarConstants.PROP_SENSOR_UPDATE,this);
	}

	private void initGUI() {
		try {
			GridLayout thisLayout = new GridLayout();
			this.setLayout(thisLayout);
			thisLayout.horizontalSpacing = 0;
			thisLayout.verticalSpacing = 0;
			thisLayout.marginWidth = 0;
			thisLayout.marginHeight = 0;
			this.setSize(300, 300);
			this.layout();
			
			showLayoutData = new GridData();
			showLayoutData.widthHint = 300;
			showLayoutData.heightHint = 300;
			showLayoutData.verticalAlignment = GridData.BEGINNING;
			
			hideLayoutData = new GridData();
			hideLayoutData.widthHint = 0;
			hideLayoutData.heightHint = 0;
			hideLayoutData.verticalAlignment = GridData.BEGINNING;
			
			
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
	
	/*
	private void addItem(String address, boolean expanded) {
		//generate a one-item list and pass through to addItem(List<String>...)
		List<String> tempList = new ArrayList<String>();
		tempList.add(address);
		addItem(tempList,expanded);
	}
	 */
	
	private void addItem(List<String> addresses, boolean expanded) {
		
		EventSetComposite evc = new EventSetComposite(
				this,
				SWT.NONE,Activator.getDefault().getEventSetForOscAddressList(addresses));
		evc.setLayoutData(showLayoutData);
		map.put(addresses, evc);
	}

	private String buildString(List<String> addresses) {
		String s = "Events for ";
		for(String a: addresses) {
			s = s.concat(a).concat(" ");
		}
		return s;
	}

	public void propertyChange(PropertyChangeEvent evt) {
		if(ExemplarConstants.PROP_SENSOR_UPDATE.equals(evt.getPropertyName())) {
			//contract everything
			for(Control c:map.values()) {
				c.setVisible(false);
				c.setLayoutData(hideLayoutData);
			}
			//if we have defined events for this before
			if(map.containsKey(Activator.getDefault().getActiveSensors())) {
				//open it
				map.get(Activator.getDefault().getActiveSensors()).setVisible(true);
				map.get(Activator.getDefault().getActiveSensors()).setLayoutData(showLayoutData);
			} else  {
				//new sensor combo:
				//generate an EventSet for them
				Activator.getDefault().createEventSetForOscAddressList(Activator.getDefault().getActiveSensors());
				//and generate a new ExpandItem for it
				addItem(Activator.getDefault().getActiveSensors(),true);
				
			}
			((Group)getParent()).setText(buildString(Activator.getDefault().getActiveSensors()));
			this.pack(true);
			this.layout(true);
			getParent().redraw();
		}
		
	}
	
}
