package edu.stanford.hci.exemplar.widgets;

import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.eclipse.swt.SWT;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.graphics.Rectangle;
import org.eclipse.swt.layout.FillLayout;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Tree;
import org.eclipse.swt.widgets.TreeItem;

import edu.stanford.hci.exemplar.Activator;
import edu.stanford.hci.exemplar.Event;
import edu.stanford.hci.exemplar.EventRegion;
import edu.stanford.hci.exemplar.EventRegionOrigin;
import edu.stanford.hci.exemplar.EventSet;
import edu.stanford.hci.exemplar.ExemplarConstants;


/**
* This code was edited or generated using CloudGarden's Jigloo
* SWT/Swing GUI Builder, which is free for non-commercial
* use. If Jigloo is being used commercially (ie, by a corporation,
* company or business for any purpose whatever) then you
* should purchase a license for each developer using Jigloo.
* Please visit www.cloudgarden.com for details.
* Use of Jigloo implies acceptance of these licensing terms.
* A COMMERCIAL LICENSE HAS NOT BEEN PURCHASED FOR
* THIS MACHINE, SO JIGLOO OR THIS CODE CANNOT BE USED
* LEGALLY FOR ANY CORPORATE OR COMMERCIAL PURPOSE.
*/
/**
 * Exemplar
 * Copyright (c) 2004-2007, Stanford University
 * All rights reserved.
 *
 * <p>
 * This software is distributed under the <a href="http://hci.stanford.edu/research/copyright.txt">
 * BSD License</a>.
 * </p>
 * 
 * 
 * @author <a href="http://bjoern.org/">Bjoern Hartmann</a> ( bjoern(AT)stanford.edu )
 * @author Leith Abdulla
 */
public class EventTreeComposite extends org.eclipse.swt.widgets.Composite implements PropertyChangeListener {
	private Tree eventTree;
	private final Map<EventSet,TreeItem> eventSetMap = new HashMap<EventSet,TreeItem>();
	private final Map<Event,TreeItem>  eventMap = new HashMap<Event,TreeItem>();
	private final Map<EventRegion,TreeItem> eventRegionMap = new HashMap<EventRegion,TreeItem>();
	
	
	/**
	* Auto-generated main method to display this 
	* org.eclipse.swt.widgets.Composite inside a new Shell.
	*/
	public static void main(String[] args) {
		showGUI();
	}
		
	/**
	* Auto-generated method to display this 
	* org.eclipse.swt.widgets.Composite inside a new Shell.
	*/
	public static void showGUI() {
		Display display = Display.getDefault();
		Shell shell = new Shell(display);
		EventTreeComposite inst = new EventTreeComposite(shell, SWT.NULL);
		Point size = inst.getSize();
		shell.setLayout(new FillLayout());
		shell.layout();
		if(size.x == 0 && size.y == 0) {
			inst.pack();
			shell.pack();
		} else {
			Rectangle shellBounds = shell.computeTrim(0, 0, size.x, size.y);
			shell.setSize(shellBounds.width, shellBounds.height);
		}
		shell.open();
		while (!shell.isDisposed()) {
			if (!display.readAndDispatch())
				display.sleep();
		}
	}

	public EventTreeComposite(org.eclipse.swt.widgets.Composite parent, int style) {
		super(parent, style);
		initGUI();/*
		Activator.getDefault().pcs.addPropertyChangeListener(ExemplarConstants.PROP_ADD_EVENT_REGION, this);
		Activator.getDefault().pcs.addPropertyChangeListener(ExemplarConstants.PROP_ADD_EVENT, this);
		Activator.getDefault().pcs.addPropertyChangeListener(ExemplarConstants.PROP_REMOVE_EVENT_REGION, this);
		Activator.getDefault().pcs.addPropertyChangeListener(ExemplarConstants.PROP_REMOVE_EVENT, this);
		Activator.getDefault().pcs.addPropertyChangeListener(ExemplarConstants.PROP_RENAME_EVENT, this);
		Activator.getDefault().pcs.addPropertyChangeListener(ExemplarConstants.PROP_RENAME_EVENT_OUTPUT, this);
		Activator.getDefault().pcs.addPropertyChangeListener(ExemplarConstants.PROP_SENSOR_UPDATE, this);
		*/
	}

	private void initGUI() {
		try {
			{

			}
			GridLayout thisLayout = new GridLayout();
			thisLayout.makeColumnsEqualWidth = true;
			thisLayout.marginWidth = 0;
			thisLayout.marginHeight = 0;
			thisLayout.horizontalSpacing = 0;
			thisLayout.verticalSpacing = 0;
			this.setLayout(thisLayout);
			{
				GridData eventTreeLData = new GridData();
				eventTreeLData.widthHint = 300;
				eventTreeLData.heightHint = 200;
				eventTree = new Tree(this, SWT.NONE);
				eventTree.setLayoutData(eventTreeLData);
				eventTree.addSelectionListener(new SelectionAdapter() {
					public void widgetSelected(SelectionEvent evt) {
						eventTreeWidgetSelected(evt);
					}
				});

			}
			this.layout();
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
	//generate a tree for the current model state from scratch
	public void generateTree() {
		for(EventSet es: Activator.getDefault().getEventSets()) {
			for(Event e:es.getEvents()) {
				if(e.getRegions().size()>0) {
					for(EventRegion r:e.getRegions()) {
						addEventRegion(es, e, r);
					}
				}
			}
		}
	}

	public void propertyChange(PropertyChangeEvent evt) {
		if(ExemplarConstants.PROP_ADD_EVENT_REGION.equals(evt.getPropertyName())){
			addEventRegion(((Event)evt.getOldValue()).getEventSet(),(Event)evt.getOldValue(),(EventRegion)evt.getNewValue());
		}
		else if(ExemplarConstants.PROP_ADD_EVENT.equals(evt.getPropertyName())){
			addEventRegion(((Event)evt.getNewValue()).getEventSet(),(Event)evt.getNewValue(),null);
		}
		else if(ExemplarConstants.PROP_REMOVE_EVENT_REGION.equals(evt.getPropertyName())){
			
			removeEventRegion(((Event)evt.getOldValue()).getEventSet(),(Event)evt.getOldValue(),(EventRegion)evt.getNewValue());
			eventTree.deselectAll();
			
		}
		else if(ExemplarConstants.PROP_REMOVE_EVENT.equals(evt.getPropertyName())){
			
			removeEvent(((Event)evt.getNewValue()).getEventSet(),(Event)evt.getNewValue());
			eventTree.deselectAll();
			
		}
		else if(ExemplarConstants.PROP_RENAME_EVENT.equals(evt.getPropertyName())){
			eventMap.get((Event)evt.getNewValue()).setText(getEventText((Event)evt.getNewValue()));
		}
		else if(ExemplarConstants.PROP_RENAME_EVENT_OUTPUT.equals(evt.getPropertyName())){
			eventMap.get((Event)evt.getNewValue()).setText(getEventText((Event)evt.getNewValue()));
		}
		else if(ExemplarConstants.PROP_SENSOR_UPDATE.equals(evt.getPropertyName())){
			removeUnchangedEventSets();
		}
		
	}

	private void removeUnchangedEventSets() {
		//Activator.getDefault().getWorkbench().getDisplay().asyncExec (new Runnable () {
		//	public void run () {
				List<EventSet> deleteList = new ArrayList<EventSet>();
				for(Map.Entry<EventSet,TreeItem> entry:eventSetMap.entrySet()) {
					if(!entry.getKey().hasBeenModified() && !entry.getKey().getOscAddresses().equals(Activator.getDefault().getActiveSensors())) {
						deleteList.add(entry.getKey());
					}
				}
				eventTree.deselectAll();
				//now delete them one by one
				for(EventSet es:deleteList) {
					for(Event e:es.getEvents()) {
						for(EventRegion r:e.getRegions()) {
							if(r.getOrigin().equals(EventRegionOrigin.USER_CREATED)) {
								TreeItem item = eventRegionMap.get(r);
								eventRegionMap.remove(r);
								if(item!=null)
									item.dispose();
							}
						}
						TreeItem item = eventMap.get(e);
						eventMap.remove(e);
						if(item!=null)
							item.dispose();
					}
					TreeItem item2 = eventSetMap.get(es);
					eventSetMap.remove(es);
					item2.dispose();
				}
				
				//now possibly add the new one
				EventSet es = Activator.getDefault().getActiveEventSet();
				if(!eventSetMap.containsKey(es)) {
					for(Event e: es.getEvents()) {
						addEventRegion(es,e,null); // none of these should have any regions
					}
				}
		//	}
		//});
	}

	private String getEventText(Event e) {
		return ("Event "+e.getName()+" - outputs to: "+e.getKey());
	}
	private void removeEventSet(EventSet eventSet) {
		TreeItem item2 = eventSetMap.get(eventSet);
		eventSetMap.remove(eventSet);
		item2.dispose();
	}

	private void removeEvent(EventSet eventSetIn, Event eventIn) {
	
		final EventSet eventSet = eventSetIn;
		final Event event = eventIn;
		
		//Activator.getDefault().getWorkbench().getDisplay().asyncExec (new Runnable () {
		//	public void run () {
				eventTree.deselectAll();
				TreeItem item = eventMap.get(event);
				eventMap.remove(event);
				item.dispose();
				//logic?
				//if the event set (parent) of the event we just deleted now 
				//has 0 events, delete it
				if(eventSetMap.get(eventSet).getItemCount()==0) {
					removeEventSet(eventSet);
				}
		//	}
		//});
	}

	private void removeEventRegion(EventSet eventSetIn, Event eventIn, EventRegion regionIn) {
		final EventSet eventSet = eventSetIn;
		final Event event = eventIn;
		final EventRegion region = regionIn;
		//Activator.getDefault().getWorkbench().getDisplay().asyncExec (new Runnable () {
		//	public void run () {
				eventTree.deselectAll();
				TreeItem item = eventRegionMap.get(region);
				eventRegionMap.remove(region);
				item.dispose();
				//logic?
				//if the event (parent) of the region we deleted now has 0 regions,
				//delete it
				if(eventMap.get(event).getItemCount()==0) {
					removeEvent(eventSet,event);
				}
		//	}
		//});
	}

	private void addEventRegion(EventSet esIn, Event eIn, EventRegion rIn) {
		final EventSet es = esIn;
		final Event e = eIn;
		final EventRegion r = rIn;
		//Activator.getDefault().getWorkbench().getDisplay().asyncExec (new Runnable () {
		//	public void run () {
				//	this event has some data - so add it and its parents
				//event set
				if(eventSetMap.get(es)==null) {
					//add a new tree item
					TreeItem item = new TreeItem(eventTree,0);
					eventSetMap.put(es,item);
					item.setData("reference", es);
					//text if it has only one sensor
					if(es.getOscAddresses().size()==1) {
						item.setText("Events for Sensor "+es.getOscAddresses().get(0));
					}
					//text if it has multiple sensors
					if(es.getOscAddresses().size()>1) {
						String text = "";
						for(String s: es.getOscAddresses()) {
							text = text.concat(s).concat(" ");
							item.setText("Events for Sensors "+text);
						}
					}
				}
				//event
				if(eventMap.get(e)==null) {
					TreeItem item = new TreeItem(eventSetMap.get(es),0);
					eventMap.put(e,item);
					item.setData("reference", e);
					item.setText(getEventText(e));
				}
				//region
				if(r==null)
					return;
				if(r.getOrigin().equals(EventRegionOrigin.USER_CREATED)) {
					
					//have to execute in UI thread
					if(eventRegionMap.get(r)==null) {
								TreeItem item = new TreeItem(eventMap.get(e),0);
								eventRegionMap.put(r, item);
								item.setData("reference", r);
								item.setText("Marked Region");
					}
				}
		//	}
		//});
	}
	
	private void eventTreeWidgetSelected(SelectionEvent evt) {
		if(!eventTree.isFocusControl()) {
			// when disposing items from a tree that were seletected at deletion time,
			// (even when deselectAll is called), the tree auto-fires a selection event
			// however, in this case, the tree will not be the focus control
			// so we can catch this behavior and ignore it.
			return;
		}
		
		if(((TreeItem)evt.item).getData("reference") instanceof EventRegion) {
			//make the sensor active
			EventRegion r = (EventRegion)((TreeItem)evt.item).getData("reference");
			Event e = (Event)(((TreeItem)evt.item).getParentItem().getData("reference"));
			EventSet es = e.getEventSet();
			Activator.getDefault().replaceActiveSensors(es.getOscAddresses());
			//make the event active
			e.makeActive();
			//pause display and zoom to ((TreeItem)evt.item).getData("reference")
			Activator.getDefault().pcs.firePropertyChange(ExemplarConstants.PROP_SHOW_USER_REGION, null, r);
			//r.getStartTime(),r.getEndTime();
		} else if (((TreeItem)evt.item).getData("reference") instanceof Event) {
			//make the sensor active
			Event e = (Event)((TreeItem)evt.item).getData("reference");
			EventSet es = e.getEventSet();
			Activator.getDefault().replaceActiveSensors(es.getOscAddresses());
			//make the event active
			e.makeActive();
		} else if (((TreeItem)evt.item).getData("reference") instanceof EventSet) {
			//make the sensor set active
			EventSet es = (EventSet)((TreeItem)evt.item).getData("reference");
			Activator.getDefault().replaceActiveSensors(es.getOscAddresses());
		} 
	}

}
