package edu.stanford.hci.exemplar.widgets;
import org.eclipse.swt.SWT;
import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.graphics.Rectangle;
import org.eclipse.swt.layout.FillLayout;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Canvas;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Shell;

import com.cloudgarden.resource.SWTResourceManager;

import edu.stanford.hci.exemplar.Activator;


/**
* This code was edited or generated using CloudGarden's Jigloo
* SWT/Swing GUI Builder, which is free for non-commercial
* use. If Jigloo is being used commercially (ie, by a corporation,
* company or business for any purpose whatever) then you
* should purchase a license for each developer using Jigloo.
* Please visit www.cloudgarden.com for details.
* Use of Jigloo implies acceptance of these licensing terms.
* A COMMERCIAL LICENSE HAS NOT BEEN PURCHASED FOR
* THIS MACHINE, SO JIGLOO OR THIS CODE CANNOT BE USED
* LEGALLY FOR ANY CORPORATE OR COMMERCIAL PURPOSE.
*/
/**
 * Exemplar
 * Copyright (c) 2004-2007, Stanford University
 * All rights reserved.
 *
 * <p>
 * This software is distributed under the <a href="http://hci.stanford.edu/research/copyright.txt">
 * BSD License</a>.
 * </p>
 * 
 * 
 * @author <a href="http://bjoern.org/">Bjoern Hartmann</a> ( bjoern(AT)stanford.edu )
 * @author Leith Abdulla
 */
public class MapFilterComposite extends org.eclipse.swt.widgets.Composite {

	{
		//Register as a resource user - SWTResourceManager will
		//handle the obtaining and disposing of resources
		SWTResourceManager.registerResourceUser(this);
	}

	private Canvas mapCanvas;
	private Label label2;
	private Label arrowLabel;
	private Canvas arrowCanvas;
	private Canvas outCanvas2;
	private Canvas spacer;
	private Label label3;
	private Label label1;
	private Canvas outCanvas;
	private Canvas inputCanvas;

	/**
	* Auto-generated main method to display this 
	* org.eclipse.swt.widgets.Composite inside a new Shell.
	*/
	public static void main(String[] args) {
		showGUI();
	}
		
	/**
	* Auto-generated method to display this 
	* org.eclipse.swt.widgets.Composite inside a new Shell.
	*/
	public static void showGUI() {
		Display display = Display.getDefault();
		Shell shell = new Shell(display);
		MapFilterComposite inst = new MapFilterComposite(shell, SWT.NULL);
		Point size = inst.getSize();
		shell.setLayout(new FillLayout());
		shell.layout();
		if(size.x == 0 && size.y == 0) {
			inst.pack();
			shell.pack();
		} else {
			Rectangle shellBounds = shell.computeTrim(0, 0, size.x, size.y);
			shell.setSize(shellBounds.width, shellBounds.height);
		}
		shell.open();
		while (!shell.isDisposed()) {
			if (!display.readAndDispatch())
				display.sleep();
		}
	}

	public MapFilterComposite(org.eclipse.swt.widgets.Composite parent, int style) {
		super(parent, style);
		initGUI();
	}

	private void initGUI() {
		try {
			GridLayout thisLayout = new GridLayout();
			this.setLayout(thisLayout);
			this.setBackground(SWTResourceManager.getColor(212,208,200));
			{
				label1 = new Label(this, SWT.NONE);
				label1.setText("in");
				GridData label1LData = new GridData();
				label1LData.horizontalAlignment = GridData.CENTER;
				label1.setLayoutData(label1LData);
				
			}
			{
				label2 = new Label(this, SWT.NONE);
				GridData label2LData = new GridData();
				label2LData.horizontalAlignment = GridData.CENTER;
				label2.setLayoutData(label2LData);
				label2.setText("mapping");
			}
			{
				label3 = new Label(this, SWT.NONE);
				GridData label3LData = new GridData();
				label3LData.horizontalAlignment = GridData.CENTER;
				label3.setLayoutData(label3LData);
				label3.setText("out");
			}
			{
				GridData inputCanvasLData = new GridData();
				inputCanvasLData.widthHint = 15;
				inputCanvasLData.heightHint = 100;
				inputCanvas = new Canvas(this, SWT.NONE);
				inputCanvas.setLayoutData(inputCanvasLData);
				inputCanvas.setBackground(SWTResourceManager.getColor(255, 255, 255));
			}
			thisLayout.numColumns = 3;
			{
				mapCanvas = new Canvas(this, SWT.NONE);
				mapCanvas.setBackground(SWTResourceManager.getColor(255, 255, 255));
				GridData mapCanvasLData = new GridData();
				mapCanvasLData.widthHint = 100;
				mapCanvasLData.heightHint = 100;
				mapCanvas.setLayoutData(mapCanvasLData);
				mapCanvas.setSize(100, 100);
			}
			{
				GridData outCanvasLData = new GridData();
				outCanvasLData.heightHint = 100;
				outCanvasLData.widthHint = 15;
				outCanvas = new Canvas(this, SWT.NONE);
				outCanvas.setLayoutData(outCanvasLData);
				outCanvas.setBackground(SWTResourceManager.getColor(255, 255, 255));
			}
			{
				spacer = new Canvas(this, SWT.NONE);
				GridData spacerLData = new GridData();
				spacerLData.widthHint = 15;
				spacerLData.heightHint = 15;
				spacer.setLayoutData(spacerLData);
				spacer.setSize(15, 15);
			}
			{
				outCanvas2 = new Canvas(this, SWT.NONE);
				GridData outCanvas2LData = new GridData();
				outCanvas2LData.widthHint = 100;
				outCanvas2LData.heightHint = 15;
				outCanvas2.setLayoutData(outCanvas2LData);
				outCanvas2.setBackground(SWTResourceManager.getColor(255, 255, 255));
			}
			{
				arrowLabel = new Label(this, SWT.NONE);
				GridData arrowLabelLData = new GridData();
				arrowLabelLData.widthHint = 15;
				arrowLabelLData.heightHint = 15;
				arrowLabel.setLayoutData(arrowLabelLData);
				arrowLabel.setImage(Activator.getImageDescriptor("icons/fliparrow.png").createImage());
			}
						this.layout();
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

}
