package edu.stanford.hci.exemplar.widgets;

import java.util.Iterator;
import java.util.List;

import org.eclipse.swt.SWT;
import org.eclipse.swt.events.MouseAdapter;
import org.eclipse.swt.events.MouseEvent;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.graphics.Rectangle;
import org.eclipse.swt.layout.FillLayout;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Scale;
import org.eclipse.swt.widgets.Shell;

import edu.stanford.hci.exemplar.Activator;
import edu.stanford.hci.exemplar.Event;
import edu.stanford.hci.exemplar.EventSet;
import edu.stanford.hci.exemplar.EventType;
import edu.stanford.hci.exemplar.ScaleBaseline;
import edu.stanford.hci.exemplar.Sensor;

/**
* This code was edited or generated using CloudGarden's Jigloo
* SWT/Swing GUI Builder, which is free for non-commercial
* use. If Jigloo is being used commercially (ie, by a corporation,
* company or business for any purpose whatever) then you
* should purchase a license for each developer using Jigloo.
* Please visit www.cloudgarden.com for details.
* Use of Jigloo implies acceptance of these licensing terms.
* A COMMERCIAL LICENSE HAS NOT BEEN PURCHASED FOR
* THIS MACHINE, SO JIGLOO OR THIS CODE CANNOT BE USED
* LEGALLY FOR ANY CORPORATE OR COMMERCIAL PURPOSE.
*/
/**
 * Exemplar
 * Copyright (c) 2004-2007, Stanford University
 * All rights reserved.
 *
 * <p>
 * This software is distributed under the <a href="http://hci.stanford.edu/research/copyright.txt">
 * BSD License</a>.
 * </p>
 * 
 * 
 * @author <a href="http://bjoern.org/">Bjoern Hartmann</a> ( bjoern(AT)stanford.edu )
 * @author Leith Abdulla
 */
public class ScaleFilterComposite extends org.eclipse.swt.widgets.Composite {
	private Scale scale;
	private Button btnInvert;
	private Label label1;
	private float factor = 1.0f;
	private Button btnBottom;
	private Label label2;
	private Button btnMiddle;
	private Composite composite1;
	private int sign = 1;
	private MoveButtonComposite moveButtonComposite;

	/**
	* Auto-generated main method to display this 
	* org.eclipse.swt.widgets.Composite inside a new Shell.
	*/
	public static void main(String[] args) {
		showGUI();
	}
		
	/**
	* Auto-generated method to display this 
	* org.eclipse.swt.widgets.Composite inside a new Shell.
	*/
	public static void showGUI() {
		Display display = Display.getDefault();
		Shell shell = new Shell(display);
		ScaleFilterComposite inst = new ScaleFilterComposite(shell, SWT.NULL);
		Point size = inst.getSize();
		shell.setLayout(new FillLayout());
		shell.layout();
		if(size.x == 0 && size.y == 0) {
			inst.pack();
			shell.pack();
		} else {
			Rectangle shellBounds = shell.computeTrim(0, 0, size.x, size.y);
			shell.setSize(shellBounds.width, shellBounds.height);
		}
		shell.open();
		while (!shell.isDisposed()) {
			if (!display.readAndDispatch())
				display.sleep();
		}
	}

	public ScaleFilterComposite(org.eclipse.swt.widgets.Composite parent, int style) {
		super(parent, style);
		initGUI();
	}

	private void initGUI() {
		try {
			GridLayout thisLayout = new GridLayout();
			thisLayout.numColumns = 2;
			this.setLayout(thisLayout);
			{
				btnInvert = new Button(this, SWT.CHECK | SWT.LEFT);
				btnInvert.setText("Invert Signal (x=-x)");
				btnInvert.addMouseListener(new MouseAdapter() {
					public void mouseUp(MouseEvent evt) {
						btnInvertMouseUp(evt);
					}
				});
				btnInvert.addSelectionListener(new SelectionAdapter() {
					public void widgetSelected(SelectionEvent evt) {
						btnInvertWidgetSelected(evt);
					}
				});
			}
			{
				GridData moveButtonCompositeLData = new GridData();
				moveButtonCompositeLData.verticalSpan = 4;
				moveButtonComposite = new MoveButtonComposite(this, SWT.NONE);
				moveButtonComposite.setLayoutData(moveButtonCompositeLData);
				((org.eclipse.swt.layout.GridLayout)moveButtonComposite.getLayout()).makeColumnsEqualWidth = true;
				((org.eclipse.swt.layout.GridLayout)moveButtonComposite.getLayout()).marginWidth = 0;
				((org.eclipse.swt.layout.GridLayout)moveButtonComposite.getLayout()).marginHeight = 0;
				((org.eclipse.swt.layout.GridLayout)moveButtonComposite.getLayout()).verticalSpacing = 1;
			}
			{
				label1 = new Label(this, SWT.NONE);
				label1.setText("Scale [0..1..2]");
			}
			{
				scale = new Scale(this, SWT.NONE);
				scale.setSelection(10);
				scale.setMaximum(20);
				scale.setPageIncrement(2);
				scale.addMouseListener(new MouseAdapter() {
					public void mouseUp(MouseEvent evt) {
						scaleMouseUp(evt);
					}
				});
				scale.addSelectionListener(new SelectionAdapter() {
					public void widgetSelected(SelectionEvent evt) {
						scaleWidgetSelected(evt);
					}
				});
			}
			{
				composite1 = new Composite(this, SWT.NONE);
				GridLayout composite1Layout = new GridLayout();
				composite1Layout.numColumns = 3;
				composite1Layout.marginHeight = 1;
				composite1Layout.verticalSpacing = 0;
				composite1Layout.marginWidth = 0;
				composite1Layout.horizontalSpacing = 0;
				composite1.setLayout(composite1Layout);
				{
					label2 = new Label(composite1, SWT.NONE);
					label2.setText("From:");
				}
				{
					btnMiddle = new Button(composite1, SWT.RADIO | SWT.LEFT);
					btnMiddle.setText("Center");
					btnMiddle.setSelection(true);
					btnMiddle.addSelectionListener(new SelectionAdapter() {
						public void widgetSelected(SelectionEvent evt) {
							btnMiddleWidgetSelected(evt);
						}
					});
				}
				{
					btnBottom = new Button(composite1, SWT.RADIO | SWT.LEFT);
					btnBottom.setText("Bottom");
					btnBottom.addSelectionListener(new SelectionAdapter() {
						public void widgetSelected(SelectionEvent evt) {
							btnBottomWidgetSelected(evt);
						}
					});
				}
			}
			this.layout();
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
	
	private void btnInvertWidgetSelected(SelectionEvent evt) {
		
		if(btnInvert.getSelection())
			sign=-1;
		else
			sign=1;
		updateModel();
	}
	
	private void scaleWidgetSelected(SelectionEvent evt) {
		
		//factor = ((float)scale.getSelection())/10;
		if(scale.getSelection()>10) {
			factor = 1.f + ((float)(scale.getSelection()-10)/10.f)*4.f;
		} else {
			factor = ((float)(scale.getSelection())/10.f);
		}
		updateModel();
	}

	private void updateModel() {
		Sensor s = Activator.getDefault().getSingleActiveSensor();
		if (s!=null) {
			s.setScaleFactor(((float)sign)*factor);
			if (btnMiddle.getSelection()) {
				s.setScaleBaseline(ScaleBaseline.MIDDLE);
			} else {
				s.setScaleBaseline(ScaleBaseline.BOTTOM);
			}
		}
	}

	public void setScale(float scaleFactor) {
		if(scaleFactor < 0) {
			sign=-1;
			btnInvert.setSelection(true);
		}else {
			sign=1;
			btnInvert.setSelection(false);
		}
		factor = (float)Math.abs(scaleFactor);
		if(factor>=1.f) {
			scale.setSelection((int)(10.f/4.f*(factor-1)+10));
		} else {
			scale.setSelection((int)(factor*10));
		}
		//scale.setSelection((int)(factor*10));
		
	}
	
	private void scaleMouseUp(MouseEvent evt) {
		Activator.getDefault().eventSetRecalculate();
	}
	
	private void btnInvertMouseUp(MouseEvent evt) {
		Activator.getDefault().eventSetRecalculate();
	}

	public void setScaleBaselise(ScaleBaseline sb) {
		if(ScaleBaseline.BOTTOM.equals(sb)) {
			btnMiddle.setSelection(false);
			btnBottom.setSelection(true);
		} else {
			btnMiddle.setSelection(true);
			btnBottom.setSelection(false);
		}
	}
	
	private void btnMiddleWidgetSelected(SelectionEvent evt) {
		btnMiddle.setSelection(true);
		
		updateModel();
	}
	
	private void btnBottomWidgetSelected(SelectionEvent evt) {
		btnMiddle.setSelection(false);
		
		updateModel();
	}
}
