package edu.stanford.hci.exemplar.widgets;

import java.util.Collections;
import java.util.Set;

import org.eclipse.swt.SWT;
import org.eclipse.swt.events.MouseAdapter;
import org.eclipse.swt.events.MouseEvent;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Combo;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Shell;

import edu.stanford.hci.exemplar.Activator;


/**
* This code was edited or generated using CloudGarden's Jigloo
* SWT/Swing GUI Builder, which is free for non-commercial
* use. If Jigloo is being used commercially (ie, by a corporation,
* company or business for any purpose whatever) then you
* should purchase a license for each developer using Jigloo.
* Please visit www.cloudgarden.com for details.
* Use of Jigloo implies acceptance of these licensing terms.
* A COMMERCIAL LICENSE HAS NOT BEEN PURCHASED FOR
* THIS MACHINE, SO JIGLOO OR THIS CODE CANNOT BE USED
* LEGALLY FOR ANY CORPORATE OR COMMERCIAL PURPOSE.
*/
/**
 * Exemplar
 * Copyright (c) 2004-2007, Stanford University
 * All rights reserved.
 *
 * <p>
 * This software is distributed under the <a href="http://hci.stanford.edu/research/copyright.txt">
 * BSD License</a>.
 * </p>
 * 
 * 
 * @author <a href="http://bjoern.org/">Bjoern Hartmann</a> ( bjoern(AT)stanford.edu )
 * @author Leith Abdulla
 */
public class SelectOneOscAddressDialog extends org.eclipse.swt.widgets.Dialog {

	private Shell dialogShell;
	private Button buttonCancel;
	private Button buttonOk;
	private Combo sensorCombo;
	private Label label1;
	
	private String value = null;

	/**
	* Auto-generated main method to display this 
	* org.eclipse.swt.widgets.Dialog inside a new Shell.
	*/
	public static void main(String[] args) {
		try {
			Display display = Display.getDefault();
			Shell shell = new Shell(display);
			SelectOneOscAddressDialog inst = new SelectOneOscAddressDialog(shell, SWT.NULL);
			inst.open();
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	public SelectOneOscAddressDialog(Shell parent, int style) {
		super(parent, style);
	}

	public String open() {
		try {
			Shell parent = getParent();
			dialogShell = new Shell(parent, SWT.DIALOG_TRIM | SWT.APPLICATION_MODAL);

			GridLayout dialogShellLayout = new GridLayout();
			dialogShellLayout.numColumns = 2;
			dialogShell.setLayout(dialogShellLayout);
			{
				label1 = new Label(dialogShell, SWT.NONE);
				label1.setText("Choose sensor to export:");
			}
			{
				sensorCombo = new Combo(dialogShell, SWT.NONE);
				
				Set<String> names = Activator.getDefault().getSensorNames();
				
				for(String s:names) {
					sensorCombo.add(s);
				}
				
			}
			{
				buttonOk = new Button(dialogShell, SWT.PUSH | SWT.CENTER);
				GridData buttonOkLData = new GridData();
				buttonOkLData.horizontalAlignment = GridData.END;
				buttonOk.setLayoutData(buttonOkLData);
				buttonOk.setText("Ok");
				buttonOk.addMouseListener(new MouseAdapter() {
					public void mouseDown(MouseEvent evt) {
						buttonOkMouseDown(evt);
					}
				});
			}
			{
				buttonCancel = new Button(dialogShell, SWT.PUSH | SWT.CENTER);
				buttonCancel.setText("Cancel");
				buttonCancel.addMouseListener(new MouseAdapter() {
					public void mouseDown(MouseEvent evt) {
						buttonCancelMouseDown(evt);
					}
				});
			}
			dialogShell.layout();
			dialogShell.pack();
			dialogShell.setSize(254, 85);
			dialogShell.open();
			Display display = dialogShell.getDisplay();
			while (!dialogShell.isDisposed()) {
				if (!display.readAndDispatch())
					display.sleep();
			}
			
		} catch (Exception e) {
			e.printStackTrace();
		}
		return value;
	}
	
	private void buttonOkMouseDown(MouseEvent evt) {
		int index = sensorCombo.getSelectionIndex();
		if(index>=0) {
			value = sensorCombo.getItem(index);
		}
		dialogShell.dispose();
	}
	
	private void buttonCancelMouseDown(MouseEvent evt) {
		value = null;
		dialogShell.dispose();
	}

}
