package edu.stanford.hci.exemplar.widgets;

import org.eclipse.swt.SWT;
import org.eclipse.swt.custom.CLabel;
import org.eclipse.swt.events.MouseAdapter;
import org.eclipse.swt.events.MouseEvent;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.graphics.Rectangle;
import org.eclipse.swt.layout.FillLayout;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Scale;
import org.eclipse.swt.widgets.Shell;

import edu.stanford.hci.exemplar.Activator;
import edu.stanford.hci.exemplar.Sensor;

/**
* This code was edited or generated using CloudGarden's Jigloo
* SWT/Swing GUI Builder, which is free for non-commercial
* use. If Jigloo is being used commercially (ie, by a corporation,
* company or business for any purpose whatever) then you
* should purchase a license for each developer using Jigloo.
* Please visit www.cloudgarden.com for details.
* Use of Jigloo implies acceptance of these licensing terms.
* A COMMERCIAL LICENSE HAS NOT BEEN PURCHASED FOR
* THIS MACHINE, SO JIGLOO OR THIS CODE CANNOT BE USED
* LEGALLY FOR ANY CORPORATE OR COMMERCIAL PURPOSE.
*/
/**
 * Exemplar
 * Copyright (c) 2004-2007, Stanford University
 * All rights reserved.
 *
 * <p>
 * This software is distributed under the <a href="http://hci.stanford.edu/research/copyright.txt">
 * BSD License</a>.
 * </p>
 * 
 * 
 * @author <a href="http://bjoern.org/">Bjoern Hartmann</a> ( bjoern(AT)stanford.edu )
 * @author Leith Abdulla
 */
public class SmootheFilterComposite extends Composite {
	private Scale scale;
	private CLabel cLabel1;
	private CLabel cLabel2;
	private Composite composite1;
	private Label label1;
	private MoveButtonComposite moveButtonComposite;

	/**
	* Auto-generated main method to display this 
	* org.eclipse.swt.widgets.Composite inside a new Shell.
	*/
	public static void main(String[] args) {
		showGUI();
	}
		
	/**
	* Auto-generated method to display this 
	* org.eclipse.swt.widgets.Composite inside a new Shell.
	*/
	public static void showGUI() {
		Display display = Display.getDefault();
		Shell shell = new Shell(display);
		SmootheFilterComposite inst = new SmootheFilterComposite(shell, SWT.NULL);
		Point size = inst.getSize();
		FillLayout shellLayout = new FillLayout(org.eclipse.swt.SWT.HORIZONTAL);
		shell.setLayout(shellLayout);
		shell.layout();
		if(size.x == 0 && size.y == 0) {
			inst.pack();
			shell.pack();
		} else {
			Rectangle shellBounds = shell.computeTrim(0, 0, size.x, size.y);
			shell.setSize(shellBounds.width, shellBounds.height);
		}
		shell.open();
		while (!shell.isDisposed()) {
			if (!display.readAndDispatch())
				display.sleep();
		}
	}

	public SmootheFilterComposite(org.eclipse.swt.widgets.Composite parent, int style) {
		super(parent, style);
		initGUI();
	}

	private void initGUI() {
		try {
			GridLayout thisLayout = new GridLayout();
			this.setLayout(thisLayout);
			thisLayout.numColumns = 2;
			{
				label1 = new Label(this, SWT.NONE);
				label1.setText("Amount of smoothing");
			}
			{
				GridData moveButtonCompositeLData = new GridData();
				moveButtonCompositeLData.verticalSpan = 3;
				moveButtonComposite = new MoveButtonComposite(this, SWT.NONE);
				moveButtonComposite.setLayoutData(moveButtonCompositeLData);
			}
			{
				scale = new Scale(this, SWT.NONE);
				scale.setMaximum(10);
				scale.setIncrement(2);
				scale.setPageIncrement(2);
				scale.addMouseListener(new MouseAdapter() {
					public void mouseUp(MouseEvent evt) {
						scaleMouseUp(evt);
					}
				});
				scale.addSelectionListener(new SelectionAdapter() {
					public void widgetSelected(SelectionEvent evt) {
						scaleWidgetSelected(evt);
					}
				});
			}
			{
				composite1 = new Composite(this, SWT.NONE);
				GridLayout composite1Layout = new GridLayout();
				composite1Layout.numColumns = 2;
				composite1Layout.marginHeight = 0;
				composite1Layout.marginWidth = 0;
				composite1Layout.verticalSpacing = 0;
				GridData composite1LData = new GridData();
				composite1LData.grabExcessHorizontalSpace = true;
				composite1LData.widthHint = 150;
				composite1.setLayoutData(composite1LData);
				composite1.setLayout(composite1Layout);
				{
					cLabel1 = new CLabel(composite1, SWT.NONE);
					cLabel1.setText("none");
				}
				{
					cLabel2 = new CLabel(composite1, SWT.NONE);
					GridData cLabel2LData = new GridData();
					cLabel2LData.horizontalAlignment = GridData.END;
					cLabel2LData.grabExcessHorizontalSpace = true;
					cLabel2.setLayoutData(cLabel2LData);
					cLabel2.setText("lots");
				}
			}
			this.layout();
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
	
	private void scaleWidgetSelected(SelectionEvent evt) {
		//calculate width and sd from param
		float sd;
		int width;
		width = 3 + (scale.getSelection()); //3 to 13;
		sd = 1+(scale.getSelection()/2); //1 to 6
		Sensor s = Activator.getDefault().getSingleActiveSensor();
		if(s!=null) {
			s.setSmoothe(width,sd);
		}
	}

	public void setScale(int width) {
		scale.setSelection((width-3));
	}
	
	private void scaleMouseUp(MouseEvent evt) {
		Activator.getDefault().eventSetRecalculate();
	}

}
