package edu.stanford.hci.exemplar;

import org.eclipse.swt.graphics.RGB;

/**
 * Exemplar
 * Copyright (c) 2004-2007, Stanford University
 * All rights reserved.
 *
 * <p>
 * This software is distributed under the <a href="http://hci.stanford.edu/research/copyright.txt">
 * BSD License</a>.
 * </p>
 * 
 * 
 * @author <a href="http://bjoern.org/">Bjoern Hartmann</a> ( bjoern(AT)stanford.edu )
 * @author Leith Abdulla
 */
public class ExemplarConstants {
	public static final int NUM_SENSORS = 8;
	
	public static final String PROP_REDRAW = "PROP_REDRAW";
	public static final String PROP_SENSOR_UPDATE = "PROP_SENSOR_UPDATE";
	public static final String PROP_ACTIVE_SENSOR_UPDATE = "PROP_ACTIVE_SENSOR_UPDATE";
	public static final String PROP_SENSOR_INTERESTING = "PROP_SENSOR_INTERESTING";
	public static final String PROP_MOUSE_DRAGGING = "PROP_MOUSE_DRAGGING";
	public static final String CAM_FRAME = "CAM_FRAME";
	public static final int SMOOTHEFILTER = 1001;
	public static final int DIFFFILTER = 2002;
	public static final int MAXMINFILTER = 3003;

	public static final String OSC_CLUTCH_ADDRESS = "/in0";
	
	public static final RGB BACKGROUND_COLOR = new RGB(212,208,200);
	public static final RGB HIGHLIGHT_COLOR = new RGB(128,128,128);
	public static final String PROP_EVENT_ON = "PROP_EVENT_ON";
	public static final String PROP_EVENT_OFF = "PROP_EVENT_OFF";
	public static final String PROP_CLUTCH = "PROP_CLUTCH";
	public static final String PROP_UPDATE_SCROLLBAR = "PROP_UPDATE_SCROLLBAR";
	public static final String PROP_MOVE_FILTER_UP = "PROP_MOVE_FILTER_UP";
	public static final String PROP_MOVE_FILTER_DOWN = "PROP_MOVE_FILTER_DOWN";
	public static final String PROP_USER_MOUSE_TOOL = "PROP_USER_MOUSE_TOOL";
	public static final String  PROP_REPLACE_EVENT_SET_MODEL = "PROP_REPLACE_EVENT_SET_MODEL";
	public static final String  PROP_ACTIVE_EVENT_UPDATE= "PROP_ACTIVE_EVENT_UPDATE";
	
	public static final String PROP_NEW_FILTERED_DATA = "PNFD";
	public static final String PROP_ADD_EVENT_REGION = "PAER";
	public static final String PROP_ADD_EVENT = "PAE";
	public static final String PROP_REMOVE_EVENT_REGION = "PRER";
	public static final String PROP_REMOVE_EVENT = "PRE";
	public static final String PROP_SHOW_USER_REGION = "PSUR";
	public static final String PROP_RENAME_EVENT_OUTPUT = "PROP_RENAME_EVENT_OUTPUT";
	public static final String PROP_RENAME_EVENT = "PROP_RENAME_EVENT";
	public static final String PROP_EVENTSET_MODIFIED = "PROP_EVENTSET_MODIFIED";

	public static final String PROP_ADD_EVENT_IN_UI = "PROP_ADD_EVENT_IN_UI";
	public static final String PROP_PICKED_SENSOR = "PROP_PICKED_SENSOR";
	
	public static String filterExtensionPath = "C:/dev/runtime-EclipseApplication/filters/"; //TODO: somehow figure this out dynamically. 
	
	public static final String  PROP_HW_RESET = "PROT_HW_RESET";
	
	
	
	
}
