package edu.stanford.hci.exemplar;
import java.awt.Frame;
import java.awt.Panel;

import org.eclipse.core.runtime.Platform;
import org.eclipse.swt.SWT;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.layout.RowData;
import org.eclipse.swt.layout.RowLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Canvas;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.FileDialog;
import org.eclipse.swt.widgets.Group;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Scale;
import org.eclipse.swt.widgets.Tree;
import org.eclipse.ui.part.ViewPart;

import edu.stanford.hci.exemplar.widgets.AllSensorsComposite;
import edu.stanford.hci.exemplar.widgets.EventSetContainer;
import edu.stanford.hci.exemplar.widgets.EventSetExpandBar;
import edu.stanford.hci.exemplar.widgets.EventTreeComposite;
import edu.stanford.hci.exemplar.widgets.FilterSetComposite;
import edu.stanford.hci.exemplar.widgets.SafeSaveDialog;
import edu.stanford.hci.exemplar.widgets.SignalVizComposite;

/**
* This code was edited or generated using CloudGarden's Jigloo
* SWT/Swing GUI Builder, which is free for non-commercial
* use. If Jigloo is being used commercially (ie, by a corporation,
* company or business for any purpose whatever) then you
* should purchase a license for each developer using Jigloo.
* Please visit www.cloudgarden.com for details.
* Use of Jigloo implies acceptance of these licensing terms.
* A COMMERCIAL LICENSE HAS NOT BEEN PURCHASED FOR
* THIS MACHINE, SO JIGLOO OR THIS CODE CANNOT BE USED
* LEGALLY FOR ANY CORPORATE OR COMMERCIAL PURPOSE.
*/
/**
 * Exemplar
 * Copyright (c) 2004-2007, Stanford University
 * All rights reserved.
 *
 * <p>
 * This software is distributed under the <a href="http://hci.stanford.edu/research/copyright.txt">
 * BSD License</a>.
 * </p>
 * 
 * 
 * @author <a href="http://bjoern.org/">Bjoern Hartmann</a> ( bjoern(AT)stanford.edu )
 * @author Leith Abdulla
 */
public class ExemplarViewPart extends ViewPart {

    public static final String ID_VIEW =
        "edu.stanford.hci.exemplar.ExemplarViewPart"; //$NON-NLS-1$
        private Group group1;
        private AllSensorsComposite SensorDataComposite;
        private Scale scale1;
        private Button checkEnableFilter;
        private EventTreeComposite eventTreeComposite;
        private Composite filterSetComposite;
        private Label label1;
        private Canvas spacerCanvas;
        private SignalVizComposite allsignalscomposite;
        private Group allsignalsgroup;
        private EventSetContainer expandBarTest1;
        private Composite composite1;
        private Panel panel1;
        private Group groupEvents;
        private Group groupFilters;
        private Frame frame1;
        private Composite swtAwtComposite;

    /**
     * 
     */
    public ExemplarViewPart() {
        super();
        // TODO Auto-generated constructor stub
    }

    /* (non-Javadoc)
     * @see org.eclipse.ui.IWorkbenchPart#createPartControl(org.eclipse.swt.widgets.Composite)
     */
    public void createPartControl(Composite parent) {
    	{
			RowLayout parentLayout = new RowLayout(
				org.eclipse.swt.SWT.HORIZONTAL);
			parentLayout.fill = true;
			parentLayout.wrap = false;
			parentLayout.spacing = -2;
 			parent.setLayout(parentLayout);
	    	parent.setSize(1280, 835);
			{
				group1 = new Group(parent, SWT.NONE);
				GridLayout group1Layout = new GridLayout();
				group1Layout.makeColumnsEqualWidth = true;
				group1Layout.horizontalSpacing = 0;
				group1Layout.marginWidth = 0;
				group1.setLayout(group1Layout);
				RowData group1LData = new RowData();
				group1LData.width = 72;
				group1LData.height = 809;
				group1.setLayoutData(group1LData);
				group1.setText("Incoming Data");
				{
					SensorDataComposite = new AllSensorsComposite(
						group1,
						SWT.NONE);
					RowLayout SensorDataCompositeLayout = new RowLayout(
						org.eclipse.swt.SWT.VERTICAL);
					SensorDataCompositeLayout.type = SWT.VERTICAL;
					SensorDataComposite.setLayout(SensorDataCompositeLayout);
					GridData SensorDataCompositeLData = new GridData();
					SensorDataCompositeLData.widthHint = 72;
					SensorDataCompositeLData.heightHint = 804;
					SensorDataComposite.setLayoutData(SensorDataCompositeLData);
				}
			}
			{
				
				groupFilters = new Group(parent, SWT.NONE);
				GridLayout groupFiltersLayout = new GridLayout();
				groupFilters.setLayout(groupFiltersLayout);
				groupFilters.setText("Filters");
				{
					filterSetComposite = new FilterSetComposite(groupFilters, SWT.NONE);
				}
				{
					/*
					composite1 = new Composite(groupFilters, SWT.NONE);
					GridLayout composite1Layout = new GridLayout();
					composite1Layout.makeColumnsEqualWidth = true;
					RowData composite1LData = new RowData();
					composite1LData.width = 129;
					composite1LData.height = 52;
					composite1.setLayoutData(composite1LData);
					composite1.setLayout(composite1Layout);
					composite1.setBackground(SWTResourceManager.getColor(
						128,
						128,
						128));
					{
						GridData button1LData = new GridData();
						button1LData.verticalAlignment = GridData.FILL;
						checkEnableFilter = new Button(composite1, SWT.CHECK
							| SWT.LEFT);
						checkEnableFilter.setText("FilterName");
						checkEnableFilter
							.addSelectionListener(new SelectionAdapter() {
								public void widgetSelected(SelectionEvent evt) {
									checkEnableFilterWidgetSelected(evt);
								}
							});
					}
					{
						GridData scale1LData = new GridData();
						scale1LData.widthHint = 120;
						scale1LData.heightHint = 16;
						scale1 = new Scale(composite1, SWT.NONE);
						scale1.setLayoutData(scale1LData);
						scale1.setSize(120, 16);
					}
					*/
				}
				
			}
			{
				allsignalsgroup = new Group(parent, SWT.NONE);
				GridLayout allsignalsgroupLayout = new GridLayout();
				allsignalsgroupLayout.makeColumnsEqualWidth = true;
				allsignalsgroupLayout.numColumns = 1;
				allsignalsgroup.setLayout(allsignalsgroupLayout);
				//GridData allsignalsgroupLData = new GridData();
				//allsignalsgroupLData.height = 348;
				//allsignalsgroup.setLayoutData(allsignalsgroupLData);
				allsignalsgroup.setText("Signal Visualiations");
				{

					GridData allsignalscompositeLData = new GridData();
					allsignalscompositeLData.widthHint = 610;
					allsignalscompositeLData.heightHint = 801;
					allsignalscomposite = new SignalVizComposite(allsignalsgroup,SWT.NONE);
					allsignalscomposite.setLayoutData(allsignalscompositeLData);
					//allsignalscomposite.setSize(490, 338);
				}
			}
			{
				groupEvents = new Group(parent, SWT.NONE);
				GridLayout groupEventsLayout = new GridLayout();
				groupEventsLayout.makeColumnsEqualWidth = true;
				groupEventsLayout.horizontalSpacing = 2;
				groupEventsLayout.marginHeight = 0;
				groupEventsLayout.marginWidth = 0;
				groupEventsLayout.verticalSpacing = 2;
				groupEvents.setLayout(groupEventsLayout);
				groupEvents.setText("Events");
				/*{
				 eventSetComposite1 = new EventSetComposite(
				 groupEvents,
				 SWT.NONE);
				 }*/
				/*{
					GridData expandBarTest1LData = new GridData();
					expandBarTest1LData.widthHint = 350;
					expandBarTest1 = new EventSetExpandBar(
						groupEvents,
						SWT.NONE);
					expandBarTest1.setLayoutData(expandBarTest1LData);

				}*/
				
				{
					GridData expandBarTest1LData = new GridData();
					expandBarTest1LData.widthHint = 300;
					expandBarTest1LData.verticalAlignment = GridData.BEGINNING;
					expandBarTest1LData.heightHint = 300;
					expandBarTest1 = new EventSetContainer(
						groupEvents,
						SWT.NONE);
					expandBarTest1.setLayoutData(expandBarTest1LData);

				}
				
				{
					spacerCanvas = new Canvas(groupEvents, SWT.NONE);
					spacerCanvas.setSize(300,1);
				}
				//TODO: event overview temporarily disabled
				/*
				{
					label1 = new Label(groupEvents, SWT.NONE);
					label1.setText("Overview of all events:");
				}
				{
					eventTreeComposite = new EventTreeComposite(
						groupEvents,
						SWT.NONE);
					GridData eventTreeCompositeLData = new GridData();
					eventTreeCompositeLData.widthHint = 300;
					eventTreeCompositeLData.heightHint = 250;
					
					eventTreeComposite.setLayoutData(eventTreeCompositeLData);
				}
				*/

			}
    	}
    	Activator.getDefault().pcs.firePropertyChange(ExemplarConstants.PROP_SENSOR_UPDATE, null, null);
    }

    /* (non-Javadoc)
     * @see org.eclipse.ui.IWorkbenchPart#setFocus()
     */
    public void setFocus() {
        // TODO Auto-generated method stub
    }
    
    /**
     * Cleans up all resources created by this ViewPart.
     */
    public void dispose() {
        super.dispose();
    }
    
	private void checkEnableFilterWidgetSelected(SelectionEvent evt) {
		//TEST of filter code
		//TODO: update to use Activator.getDefault().getActiveSensors()
		/*
		if(checkEnableFilter.getSelection())
			Activator.getDefault().getSensorForOscAddress(Activator.ActiveSensor).filterList.add(ExemplarConstants.MAXMINFILTER);
		else
			//empty out for now
			Activator.getDefault().getSensorForOscAddress(Activator.ActiveSensor).filterList.clear();
			*/
	}
	
	private void btnSaveWidgetSelected(SelectionEvent evt) {
				
		SafeSaveDialog dialog = new SafeSaveDialog (evt.display.getActiveShell());
		dialog.setFilterNames (new String [] {"Exemplar Files", "All Files (*.*)"});
		dialog.setFilterExtensions (new String [] {"*.exm", "*.*"}); //Windows wild cards
		dialog.setFilterPath (Platform.getLocation().toOSString()); //Workspace path
		dialog.setFileName ("exemplar-session.exm");
		String filename = dialog.open();
		
		if(filename!=null)
			Activator.getDefault().saveToFile(filename);
	}
	
	private void btnLoadWidgetSelected(SelectionEvent evt) {
		FileDialog dialog = new FileDialog (evt.display.getActiveShell(),SWT.OPEN);
		dialog.setFilterNames (new String [] {"Exemplar Files", "All Files (*.*)"});
		dialog.setFilterExtensions (new String [] {"*.exm", "*.*"}); //Windows wild cards
		dialog.setFilterPath (Platform.getLocation().toOSString()); //Workspace path
		String filename = dialog.open();
		if(filename!=null)
			Activator.getDefault().loadFromFile(filename);
		
		
	}

}