package edu.stanford.hci.exemplar.actions;

import org.eclipse.core.runtime.Platform;
import org.eclipse.jface.action.IAction;
import org.eclipse.jface.viewers.ISelection;
import org.eclipse.swt.SWT;
import org.eclipse.swt.widgets.FileDialog;
import org.eclipse.ui.IWorkbenchWindow;
import org.eclipse.ui.IWorkbenchWindowActionDelegate;

import edu.stanford.hci.exemplar.Activator;
/**
 * Exemplar
 * Copyright (c) 2004-2007, Stanford University
 * All rights reserved.
 *
 * <p>
 * This software is distributed under the <a href="http://hci.stanford.edu/research/copyright.txt">
 * BSD License</a>.
 * </p>
 * 
 * 
 * @author <a href="http://bjoern.org/">Bjoern Hartmann</a> ( bjoern(AT)stanford.edu )
 * @author Leith Abdulla
 */
public class LoadAction implements IWorkbenchWindowActionDelegate {

	private IWorkbenchWindow window;

	public void dispose() {
		// TODO Auto-generated method stub

	}

	public void init(IWorkbenchWindow window) {
		this.window=window;

	}

	public void run(IAction action) {
		
		FileDialog dialog = new FileDialog (window.getShell(),SWT.OPEN);
		dialog.setFilterNames (new String [] {"Exemplar Files", "All Files (*.*)"});
		dialog.setFilterExtensions (new String [] {"*.exm", "*.*"}); //Windows wild cards
		dialog.setFilterPath (Platform.getLocation().toOSString()); //Windows path
		String filename = dialog.open();
		if(filename!=null)
			Activator.getDefault().loadFromFile(filename);
		
	}

	public void selectionChanged(IAction action, ISelection selection) {
		// TODO Auto-generated method stub

	}

}
