package edu.stanford.hci.exemplar.preferences;

import org.eclipse.core.runtime.preferences.AbstractPreferenceInitializer;
import org.eclipse.jface.preference.IPreferenceStore;

import edu.stanford.hci.exemplar.Activator;


/**
 * Exemplar
 * Copyright (c) 2004-2007, Stanford University
 * All rights reserved.
 *
 * <p>
 * This software is distributed under the <a href="http://hci.stanford.edu/research/copyright.txt">
 * BSD License</a>.
 * </p>
 * 
 * 
 * @author <a href="http://bjoern.org/">Bjoern Hartmann</a> ( bjoern(AT)stanford.edu )
 * @author Leith Abdulla
 */
public class PreferenceInitializer extends AbstractPreferenceInitializer {

	@Override
	public void initializeDefaultPreferences() {
		IPreferenceStore store = Activator.getDefault().getPreferenceStore();
		store.setDefault(PreferenceConstants.P_COMPORT,"COM1");
		store.setDefault(PreferenceConstants.P_COMSPEED,38400);
		store.setDefault(PreferenceConstants.P_TCP_OUTPUT_PORT,9990);
		store.setDefault(PreferenceConstants.P_MAXA2DVAL,256);
		store.setDefault(PreferenceConstants.P_INPUT_PROTOCOL,PreferenceConstants.P_INPUT_OSCSERIAL);
		store.setDefault(PreferenceConstants.P_ADJUSTREGION,PreferenceConstants.P_ADJUSTOFF);
		store.setDefault(PreferenceConstants.P_UDP_OUTPUT_PORT,9999);
		store.setDefault(PreferenceConstants.P_UDP_OUTPUT_IPADDRESS,"127.0.0.1");
		store.setDefault(PreferenceConstants.P_OUTPUT_PROTOCOL,PreferenceConstants.P_OUTPUT_FLASH);
		store.setDefault(PreferenceConstants.P_UDP_INPUT_PORT,10001);
	}

}
