package edu.stanford.hci.exemplar.widgets;
import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;
import java.util.HashMap;
import java.util.Map;

import org.eclipse.swt.SWT;
import org.eclipse.swt.events.KeyAdapter;
import org.eclipse.swt.events.KeyEvent;
import org.eclipse.swt.layout.RowLayout;
import org.eclipse.swt.widgets.Group;

import com.cloudgarden.resource.SWTResourceManager;

import edu.stanford.hci.exemplar.Activator;
import edu.stanford.hci.exemplar.ExemplarConstants;

/**
* This code was edited or generated using CloudGarden's Jigloo
* SWT/Swing GUI Builder, which is free for non-commercial
* use. If Jigloo is being used commercially (ie, by a corporation,
* company or business for any purpose whatever) then you
* should purchase a license for each developer using Jigloo.
* Please visit www.cloudgarden.com for details.
* Use of Jigloo implies acceptance of these licensing terms.
* A COMMERCIAL LICENSE HAS NOT BEEN PURCHASED FOR
* THIS MACHINE, SO JIGLOO OR THIS CODE CANNOT BE USED
* LEGALLY FOR ANY CORPORATE OR COMMERCIAL PURPOSE.
*/
/**
 * Exemplar
 * Copyright (c) 2004-2007, Stanford University
 * All rights reserved.
 *
 * <p>
 * This software is distributed under the <a href="http://hci.stanford.edu/research/copyright.txt">
 * BSD License</a>.
 * </p>
 * 
 * 
 * @author <a href="http://bjoern.org/">Bjoern Hartmann</a> ( bjoern(AT)stanford.edu )
 * @author Leith Abdulla
 */
public class AllSensorsComposite extends org.eclipse.swt.widgets.Composite implements PropertyChangeListener {
	
	
	private Map<String, OneSensorComposite> sensors = new HashMap<String, OneSensorComposite>();
	private OneSensorComposite composite0, composite1, composite2, composite3, composite4, composite5, composite6, composite7;

	{
		//Register as a resource user - SWTResourceManager will
		//handle the obtaining and disposing of resources
		SWTResourceManager.registerResourceUser(this);
	}


	public static void makeSelection(OneSensorComposite a, boolean append) {
		//notify everyone(including this class) that the selection has changed
		//AllSensorsComposite.notifyExemplarSensorChange(((Group)a.getChildren()[0]).getText());
		String newAddress = a.getOSCAddress();
		if(!append) {
			Activator.getDefault().replaceActiveSensors(newAddress);			
		} else {
			//mulitple will be active
			Activator.getDefault().addToActiveSensors(newAddress,true);
		}
	}
	
	
	public AllSensorsComposite(org.eclipse.swt.widgets.Composite parent, int style) {
		super(parent, style);
		initGUI();
		if(Activator.getDefault() != null)
		{
		Activator.getDefault().pcs.addPropertyChangeListener(ExemplarConstants.PROP_SENSOR_UPDATE,this);
		}
	}

	private void initGUI() {
		try {
			RowLayout thisLayout = new RowLayout(org.eclipse.swt.SWT.HORIZONTAL);
			this.setLayout(thisLayout);
			{
				composite0 = new OneSensorComposite(this, SWT.NONE | SWT.DOUBLE_BUFFERED, "/adc0");
				composite1 = new OneSensorComposite(this, SWT.NONE | SWT.DOUBLE_BUFFERED, "/adc1");
				composite2 = new OneSensorComposite(this, SWT.NONE | SWT.DOUBLE_BUFFERED, "/adc2");
				
				composite3 = new OneSensorComposite(this, SWT.NONE | SWT.DOUBLE_BUFFERED, "/adc3");
				composite4 = new OneSensorComposite(this, SWT.NONE | SWT.DOUBLE_BUFFERED, "/adc4");
				composite5 = new OneSensorComposite(this, SWT.NONE | SWT.DOUBLE_BUFFERED, "/adc5");
				composite6 = new OneSensorComposite(this, SWT.NONE | SWT.DOUBLE_BUFFERED, "/adc6");
				composite7 = new OneSensorComposite(this, SWT.NONE | SWT.DOUBLE_BUFFERED, "/adc7");
				
				sensors.put("/adc0", composite0);
				sensors.put("/adc1", composite1);
				sensors.put("/adc2", composite2);
				sensors.put("/adc3", composite3);
				sensors.put("/adc4", composite4);
				sensors.put("/adc5", composite5);
				sensors.put("/adc6", composite6);
				sensors.put("/adc7", composite7);				
				
				}

		} catch (Exception e) {
			e.printStackTrace();
		}
	}


	public void propertyChange(PropertyChangeEvent evt) {
		if(evt.getPropertyName().equals(ExemplarConstants.PROP_SENSOR_UPDATE)) {
			//turn all old ones off
			for(Map.Entry<String, OneSensorComposite> e: sensors.entrySet()) {
				if(!e.getValue().isDisposed()) {
					if(Activator.getDefault().getActiveSensors().contains(e.getKey())) {
						//turn on sensors that were passed in the list
						e.getValue().setBackground(SWTResourceManager.getColor(255, 255, 128));
					} else {
						//turn off all others
						e.getValue().setBackground(SWTResourceManager.getColor(212, 208, 200));
					}
				}
			}
		}
	}
}
