package edu.stanford.hci.exemplar.widgets;
import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;

import org.eclipse.swt.SWT;
import org.eclipse.swt.events.ModifyEvent;
import org.eclipse.swt.events.ModifyListener;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.graphics.Rectangle;
import org.eclipse.swt.layout.FillLayout;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.layout.RowData;
import org.eclipse.swt.layout.RowLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Combo;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Text;

import com.cloudgarden.resource.SWTResourceManager;

import edu.stanford.hci.exemplar.Activator;
import edu.stanford.hci.exemplar.BigViewModel;
import edu.stanford.hci.exemplar.EventSet;
import edu.stanford.hci.exemplar.EventType;
import edu.stanford.hci.exemplar.ExemplarConstants;
import edu.stanford.hci.exemplar.Sensor;


/**
* This code was edited or generated using CloudGarden's Jigloo
* SWT/Swing GUI Builder, which is free for non-commercial
* use. If Jigloo is being used commercially (ie, by a corporation,
* company or business for any purpose whatever) then you
* should purchase a license for each developer using Jigloo.
* Please visit www.cloudgarden.com for details.
* Use of Jigloo implies acceptance of these licensing terms.
* A COMMERCIAL LICENSE HAS NOT BEEN PURCHASED FOR
* THIS MACHINE, SO JIGLOO OR THIS CODE CANNOT BE USED
* LEGALLY FOR ANY CORPORATE OR COMMERCIAL PURPOSE.
*/
/**
 * Exemplar
 * Copyright (c) 2004-2007, Stanford University
 * All rights reserved.
 *
 * <p>
 * This software is distributed under the <a href="http://hci.stanford.edu/research/copyright.txt">
 * BSD License</a>.
 * </p>
 * 
 * 
 * @author <a href="http://bjoern.org/">Bjoern Hartmann</a> ( bjoern(AT)stanford.edu )
 * @author Leith Abdulla
 */
public class BigViewWithButtonsComposite extends org.eclipse.swt.widgets.Composite implements PropertyChangeListener {

	{
		//Register as a resource user - SWTResourceManager will
		//handle the obtaining and disposing of resources
		SWTResourceManager.registerResourceUser(this);
	}

	private BigViewCanvas bigViewCanvas;
	private Composite composite6;
	private Composite composite2;
	private Label label2;
	private Combo comboOscOutput;
	private Label label1;
	private Button thresholdBtn;
	private Button patternBtn;
	private BigViewModel model;
	/**
	* Auto-generated main method to display this 
	* org.eclipse.swt.widgets.Composite inside a new Shell.
	*/
	public static void main(String[] args) {
		showGUI();
	}
		
	/**
	* Auto-generated method to display this 
	* org.eclipse.swt.widgets.Composite inside a new Shell.
	*/
	public static void showGUI() {
		Display display = Display.getDefault();
		Shell shell = new Shell(display);
		BigViewWithButtonsComposite inst = new BigViewWithButtonsComposite(shell, SWT.NULL);
		Point size = inst.getSize();
		shell.setLayout(new FillLayout());
		shell.layout();
		if(size.x == 0 && size.y == 0) {
			inst.pack();
			shell.pack();
		} else {
			Rectangle shellBounds = shell.computeTrim(0, 0, size.x, size.y);
			shell.setSize(shellBounds.width, shellBounds.height);
		}
		shell.open();
		while (!shell.isDisposed()) {
			if (!display.readAndDispatch())
				display.sleep();
		}
	}

	public BigViewWithButtonsComposite(org.eclipse.swt.widgets.Composite parent, int style) {
		super(parent, style);
		model = new BigViewModel();
		initGUI();
		
		if(Activator.getDefault() != null)
		{
			Activator.getDefault().pcs.addPropertyChangeListener(ExemplarConstants.PROP_REDRAW, this);
			Activator.getDefault().pcs.addPropertyChangeListener(ExemplarConstants.PROP_ACTIVE_EVENT_UPDATE, this);
			
		}
		
	}

	private void initGUI() {
		try {
			{

			}
			GridLayout thisLayout = new GridLayout();
			thisLayout.makeColumnsEqualWidth = true;
			thisLayout.marginHeight = 2;
			thisLayout.verticalSpacing = 2;
			//this.setLayoutData(bigViewParentLData);
			this.setLayout(thisLayout);
			//this.setSize(406, -1);
			//this.setSize(400, 245);
			{
				bigViewCanvas = new BigViewCanvas(this, SWT.DOUBLE_BUFFERED);

				GridData bigViewCanvasLData = new GridData();
				bigViewCanvasLData.widthHint = 400;
				bigViewCanvasLData.heightHint = 200;
				bigViewCanvas.setLayoutData(bigViewCanvasLData);
				bigViewCanvas.setBackground(SWTResourceManager.getColor(
					255,
					255,
					255));
			}
			{
				composite6 = new Composite(this, SWT.NONE);
				GridLayout composite6Layout = new GridLayout();
				composite6Layout.numColumns = 4;
				composite6Layout.marginHeight = 0;
				composite6Layout.verticalSpacing = 0;
				composite6.setLayout(composite6Layout);
				GridData composite6LData = new GridData();
				composite6.setLayoutData(composite6LData);
				{
					label1 = new Label(composite6, SWT.NONE);
					label1.setText("Event Type:");
				}
			
				{
					composite2 = new Composite(composite6, SWT.NONE);
					RowLayout composite2Layout = new RowLayout(
						org.eclipse.swt.SWT.HORIZONTAL);
					composite2Layout.marginTop = 0;
					composite2.setLayout(composite2Layout);
					{
						thresholdBtn = new Button(composite2, SWT.TOGGLE | SWT.CENTER);
						thresholdBtn.setText("Threshold");
						RowData button2LData = new RowData();
						button2LData.width = 57;
						button2LData.height = 23;
						thresholdBtn.setLayoutData(button2LData);
						thresholdBtn.setSelection(true);
						thresholdBtn
							.addSelectionListener(new SelectionAdapter() {
								public void widgetSelected(SelectionEvent evt) {
									thresholdBtnWidgetSelected(evt);
								}
							});
					}
					{
						patternBtn = new Button(composite2, SWT.TOGGLE
							| SWT.CENTER);
						patternBtn.setText("Pattern");
						patternBtn.addSelectionListener(new SelectionAdapter() {
							public void widgetSelected(SelectionEvent evt) {
								patternBtnWidgetSelected(evt);
							}
						});
					}
					/*{
						button4 = new Button(composite2, SWT.PUSH | SWT.CENTER);
						button4.setText("Peaks + Valleys");
						RowData button4LData = new RowData();
						button4LData.width = 100;
						button4LData.height = 23;
						button4.setLayoutData(button4LData);
					}*/
				}
				{
					label2 = new Label(composite6, SWT.NONE);
					label2.setText("Output continuous values to:");
				}
			
				{
					comboOscOutput = new Combo(composite6, SWT.NONE);
					
					comboOscOutput.addSelectionListener(new SelectionAdapter() {
						public void widgetSelected(SelectionEvent evt) {
							comboOscOutputWidgetSelected(evt);
						}
					});
					comboOscOutput.add("None");
					comboOscOutput.add("/xstream1");
					comboOscOutput.add("/xstream2");
					comboOscOutput.add("/xstream3");
					comboOscOutput.add("/xstream4");
					comboOscOutput.add("/xstream5");
					comboOscOutput.add("/xstream6");
					comboOscOutput.add("/xstream7");
					comboOscOutput.add("/xstream8");
					comboOscOutput.add("/xstream9");
					comboOscOutput.setText("None");
					/* doesn't work b/c s is still null at this point
					 * if(model.getSensor()!=null)
						comboOscOutput.add(model.getSensor().getOSCAddress());
						*/
					
				}
			}
			this.layout();
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	protected void thresholdBtnWidgetSelected(SelectionEvent evt) {
		if(model!=null) {
			EventSet eventSet = Activator.getDefault().getActiveEventSet();
			if(eventSet.getActiveEvent() !=null) {
				eventSet.getActiveEvent().setType(EventType.THRESHOLD, model.getOscAddress());//add ,model.getOscAddress());
				thresholdBtn.setSelection(true);
				patternBtn.setSelection(false);
				eventSet.getActiveEvent().recalculate(true);
			} else {
				//No active event found to set thresholds for.
				
			}
		}
		
	}
	
	protected void patternBtnWidgetSelected(SelectionEvent evt) {
		if(model!=null) {
			EventSet eventSet = Activator.getDefault().getActiveEventSet(); 
			if(eventSet.getActiveEvent() !=null) {
				eventSet.getActiveEvent().setType(EventType.PATTERN, model.getOscAddress());
				thresholdBtn.setSelection(false);
				patternBtn.setSelection(true);
				eventSet.getActiveEvent().recalculate(true);
			} else {
				//No active event found to set pattern for.
				
			}
		}
		
	}

	public void refreshButtonState() {
		
		Sensor s = model.getSensor();
		
		
		comboOscOutput.removeAll();
		comboOscOutput.add("None");
		comboOscOutput.add("/xstream1");
					comboOscOutput.add("/xstream2");
					comboOscOutput.add("/xstream3");
					comboOscOutput.add("/xstream4");
					comboOscOutput.add("/xstream5");
					comboOscOutput.add("/xstream6");
					comboOscOutput.add("/xstream7");
					comboOscOutput.add("/xstream8");
					comboOscOutput.add("/xstream9");
		String str = s.getOscOutputAddress();
		if(str !=null)
			comboOscOutput.setText(str);
		else
			comboOscOutput.setText("None");
		EventSet eventSet = Activator.getDefault().getActiveEventSet(); 
		if(eventSet.getActiveEvent()!=null) {
			if(EventType.PATTERN.equals(eventSet.getActiveEvent().getType(model.getOscAddress()))) {
				thresholdBtn.setSelection(false);
				patternBtn.setSelection(true);
			} else if (EventType.THRESHOLD.equals(eventSet.getActiveEvent().getType(model.getOscAddress()))) {
				thresholdBtn.setSelection(true);
				patternBtn.setSelection(false);
			}
		redraw();
		}
	}

	@Override
	public void dispose() {
		Activator.getDefault().pcs.removePropertyChangeListener(ExemplarConstants.PROP_REDRAW, this);
		Activator.getDefault().pcs.removePropertyChangeListener(ExemplarConstants.PROP_ACTIVE_EVENT_UPDATE, this);
		super.dispose();
	}

	@Override
	public Point computeSize(int wHint, int hHint, boolean changed) {
		return super.computeSize(wHint, hHint,changed);
		/* custom code below doesn't work anymore
		 * Control c;
		Point p = new Point(0,0);
		for(int i=0; i<getChildren().length;i++) {
			p.x=Math.max(getChildren()[i].getSize().x,p.x);
			p.y+=getChildren()[i].getSize().y;
		}

		return p;
		//return super.computeSize(wHint, hHint, changed);
		 
		 */
	}

	public BigViewModel getModel() {
		return model;
	}

	public BigViewCanvas getBigViewCanvas() {
		return bigViewCanvas;
	}

	public void addOscAddressAsFilterOutput(String s) {
		comboOscOutput.add(s);
	}
	

	public void propertyChange(PropertyChangeEvent evt) {
		if(ExemplarConstants.PROP_REDRAW.equals(evt.getPropertyName())) {
			//redraw asynchronously in the UI thread
			Display d = Activator.getDefault().getWorkbench().getDisplay();
			if(!d.isDisposed()) {
				try {
					Activator.getDefault().getWorkbench().getDisplay().asyncExec (new Runnable () {
						public void run () {
							
							if(model.isPlaying()) {
								model.computePlayingEndTime();
								
							}
								//tTo is the latest available data
								bigViewCanvas.setEndTime(model.getEndTime());
								//compute tFrom
								bigViewCanvas.setStartTime(model.getStartTime());
							
	
							
								
						}
					});
				} catch (NullPointerException e) {
					//may throw if called during Eclipse shutdown
				}
			}
		}
		else if (ExemplarConstants.PROP_ACTIVE_EVENT_UPDATE.equals(evt.getPropertyName())) {
			refreshButtonState();
		}

		
	}
	
	
	
	private void comboOscOutputWidgetSelected(SelectionEvent evt) {
		Sensor s = model.getSensor();
		if(s!=null) {
			String str = comboOscOutput.getItem(comboOscOutput.getSelectionIndex());
			if(!str.equals("None"))
				s.setOscOutputAddress(str);
			else
				s.setOscOutputAddress(null);
		}
	}

}
