package edu.stanford.hci.exemplar.widgets;
import org.eclipse.swt.SWT;
import org.eclipse.swt.events.ModifyEvent;
import org.eclipse.swt.events.ModifyListener;
import org.eclipse.swt.events.MouseAdapter;
import org.eclipse.swt.events.MouseEvent;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.graphics.Color;
import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.graphics.Rectangle;
import org.eclipse.swt.layout.FillLayout;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Canvas;
import org.eclipse.swt.widgets.Combo;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Text;

import com.cloudgarden.resource.SWTResourceManager;

import edu.stanford.hci.exemplar.Activator;
import edu.stanford.hci.exemplar.Event;
import edu.stanford.hci.exemplar.EventObserver;
import edu.stanford.hci.exemplar.ExemplarConstants;

/**
* This code was edited or generated using CloudGarden's Jigloo
* SWT/Swing GUI Builder, which is free for non-commercial
* use. If Jigloo is being used commercially (ie, by a corporation,
* company or business for any purpose whatever) then you
* should purchase a license for each developer using Jigloo.
* Please visit www.cloudgarden.com for details.
* Use of Jigloo implies acceptance of these licensing terms.
* A COMMERCIAL LICENSE HAS NOT BEEN PURCHASED FOR
* THIS MACHINE, SO JIGLOO OR THIS CODE CANNOT BE USED
* LEGALLY FOR ANY CORPORATE OR COMMERCIAL PURPOSE.
*/
/**
 * Exemplar
 * Copyright (c) 2004-2007, Stanford University
 * All rights reserved.
 *
 * <p>
 * This software is distributed under the <a href="http://hci.stanford.edu/research/copyright.txt">
 * BSD License</a>.
 * </p>
 * 
 * 
 * @author <a href="http://bjoern.org/">Bjoern Hartmann</a> ( bjoern(AT)stanford.edu )
 * @author Leith Abdulla
 */
public class EventComposite extends org.eclipse.swt.widgets.Composite implements EventObserver{
	private Label label1;
	private Label label2;
	private Text txtName;
	private Label txtType;
	private Combo comboOscOutAddress;
	private Button btnClear;
	private Button btnClose;
	private Canvas colorCanvas;
	private Label label3;
	private Composite composite1;
	private Text txtKey;
	private Event event;
	

	{
		//Register as a resource user - SWTResourceManager will
		//handle the obtaining and disposing of resources
		SWTResourceManager.registerResourceUser(this);
	}


	@Override
	public Point computeSize(int wHint, int hHint, boolean changed) {
		if(!isDisposed())
			return new Point(288,44);
		else 
			return new Point(0,0);
		//return super.computeSize(wHint, hHint, changed);
	}

	/**
	* Auto-generated main method to display this 
	* org.eclipse.swt.widgets.Composite inside a new Shell.
	*/
	public static void main(String[] args) {
		showGUI();
	}
		
	/**
	* Auto-generated method to display this 
	* org.eclipse.swt.widgets.Composite inside a new Shell.
	*/
	public static void showGUI() {
		Display display = Display.getDefault();
		Shell shell = new Shell(display);
		EventComposite inst = new EventComposite(shell, SWT.NULL);
		Point size = inst.getSize();
		shell.setLayout(new FillLayout());
		shell.layout();
		if(size.x == 0 && size.y == 0) {
			inst.pack();
			shell.pack();
		} else {
			Rectangle shellBounds = shell.computeTrim(0, 0, size.x, size.y);
			shell.setSize(shellBounds.width, shellBounds.height);
		}
		shell.open();
		while (!shell.isDisposed()) {
			if (!display.readAndDispatch())
				display.sleep();
		}
	}

	public EventComposite(org.eclipse.swt.widgets.Composite parent, int style) {
		super(parent, style);
		initGUI();
	}

	private void initGUI() {
		try {
			{

			}
			this.setLayoutData(null);
			GridLayout thisLayout = new GridLayout();
			thisLayout.makeColumnsEqualWidth = true;
			thisLayout.horizontalSpacing = 1;
			thisLayout.marginHeight = 1;
			thisLayout.marginWidth = 1;
			thisLayout.verticalSpacing = 1;
			this.setLayout(thisLayout);
			this.setSize(250, 40);
			{
				composite1 = new Composite(this, SWT.NONE);
				GridLayout composite1Layout = new GridLayout();
				composite1Layout.numColumns = 4;
				composite1Layout.verticalSpacing = 1;
				GridData composite1LData = new GridData();
				composite1LData.grabExcessHorizontalSpace = true;
				composite1LData.widthHint = 286;
				composite1.setLayoutData(composite1LData);
				composite1.setLayout(composite1Layout);
				{
					colorCanvas = new Canvas(composite1, SWT.NONE);
					GridData canvas1LData = new GridData();
					canvas1LData.verticalSpan = 2;
					canvas1LData.widthHint = 24;
					canvas1LData.heightHint = 24;
					colorCanvas.setLayoutData(canvas1LData);
					colorCanvas.setSize(24, 24);
					colorCanvas.addMouseListener(new MouseAdapter() {
						public void mouseDown(MouseEvent evt) {
							colorCanvasMouseDown(evt);
						}
					});
				}
				
				composite1.addMouseListener(new MouseAdapter() {
					public void mouseDown(MouseEvent evt) {
						composite1MouseDown(evt);
					}
				});

			}
			{
				label1 = new Label(composite1, SWT.NONE);
				label1.setText("Name:");
				GridData label1LData = new GridData();
				label1LData.widthHint = 48;
				label1LData.heightHint = 13;
				label1.setLayoutData(label1LData);
			}
			{
				label2 = new Label(composite1, SWT.NONE);
				label2.setText("Send as:");
				GridData label2LData = new GridData();
				label2LData.widthHint = 50;
				label2LData.heightHint = 13;
				label2.setLayoutData(label2LData);
			}
			/*{
				label3 = new Label(composite1, SWT.NONE);
				label3.setText("Type:");
			}*/
			{
				btnClose = new Button(composite1, SWT.TOGGLE | SWT.CENTER);
				btnClose.setText("Remove");
				GridData btnCloseLData = new GridData();
				btnCloseLData.heightHint = 14;
				btnCloseLData.horizontalAlignment = GridData.END;
				btnCloseLData.grabExcessHorizontalSpace = true;
				btnCloseLData.widthHint = 51;
				btnClose.setLayoutData(btnCloseLData);
				btnClose.addSelectionListener(new SelectionAdapter() {
					public void widgetSelected(SelectionEvent evt) {
						btnCloseWidgetSelected(evt);
					}
				});

			}
			{
				txtName = new Text(composite1, SWT.NONE);
				txtName.setText("");
				txtName.addModifyListener(new ModifyListener() {
					public void modifyText(ModifyEvent evt) {
						txtNameModifyText(evt);
					}
				});
			}
			/**{
				txtKey = new Text(composite1, SWT.NONE);
				txtKey.setText("");
				GridData txtKeyLData = new GridData();
				txtKeyLData.widthHint = 40;
				txtKeyLData.heightHint = 13;
				txtKey.setLayoutData(txtKeyLData);
				txtKey.addModifyListener(new ModifyListener() {
					public void modifyText(ModifyEvent evt) {
						txtKeyModifyText(evt);
					}
				});
			}**/
			{
				comboOscOutAddress = new Combo(composite1, SWT.NONE);
				comboOscOutAddress.add("None");
				comboOscOutAddress.add("/xevent0");
				comboOscOutAddress.add("/xevent1");
				comboOscOutAddress.add("/xevent2");
				comboOscOutAddress.add("/xevent3");
				comboOscOutAddress.add("/xevent4");
				comboOscOutAddress.add("/xevent5");
				comboOscOutAddress.add("/xevent6");
				comboOscOutAddress.add("/xevent7");
				comboOscOutAddress.add("/xevent8");
				comboOscOutAddress.add("/xevent9");
				comboOscOutAddress.setText("None");
				comboOscOutAddress.addSelectionListener(new SelectionAdapter() {
					public void widgetSelected(SelectionEvent evt) {
						comboOscOutAddressWidgetSelected(evt);
					}
				});
			}		
			/*{
				txtType = new Label(composite1, SWT.NONE);
				txtType.setText("type");
			}*/
			{
				btnClear = new Button(composite1, SWT.PUSH | SWT.CENTER);
				btnClear.setText("Reset");
				GridData btnClearLData = new GridData();
				btnClearLData.heightHint = 14;
				btnClearLData.horizontalAlignment = GridData.END;
				btnClearLData.widthHint = 51;
				btnClear.setLayoutData(btnClearLData);
				btnClear.addSelectionListener(new SelectionAdapter() {
					public void widgetSelected(SelectionEvent evt) {
						btnClearWidgetSelected(evt);
					}
				});
			}
	

			this.layout();
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	public void setEvent(Event e) {
		this.event = e;
		event.attach(this);
		Update();
		
	}

	// called if model changes
	public void Update() {
		colorCanvas.setBackground(SWTResourceManager.getColor(event.getColor().red,event.getColor().green,event.getColor().blue));
		if(event.isActive()) {
			Color c= SWTResourceManager.getColor(
					ExemplarConstants.HIGHLIGHT_COLOR.red,
					ExemplarConstants.HIGHLIGHT_COLOR.green,
					ExemplarConstants.HIGHLIGHT_COLOR.blue);
			composite1.setBackground(c);
			label1.setBackground(c);
			label2.setBackground(c);
			
			
			
		} else {
			Color c= SWTResourceManager.getColor(
					ExemplarConstants.BACKGROUND_COLOR.red,
					ExemplarConstants.BACKGROUND_COLOR.green,
					ExemplarConstants.BACKGROUND_COLOR.blue);
			composite1.setBackground(c);
			label1.setBackground(c);
			label2.setBackground(c);
			
		}
		if(!txtName.getText().equals(event.getName()))
			txtName.setText(event.getName());
		/*if(!txtKey.getText().equals(event.getKey()))
			txtKey.setText(event.getKey());*/
	
		if(event.getKey()==null) {
			comboOscOutAddress.setText("None");
		} else {
			comboOscOutAddress.setText(event.getKey());
		}
		redraw();
	}
	
	private void composite1MouseDown(MouseEvent evt) {
		event.makeActive();
	}
	
	private void colorCanvasMouseDown(MouseEvent evt) {
		event.makeActive();
	}
	
	public void btnCloseWidgetSelected(SelectionEvent evt) {
		event.getEventSet().removeEvent(event);
		event.dispose();
		event = null;
		this.dispose();
		Activator.getDefault().pcs.firePropertyChange(ExemplarConstants.PROP_UPDATE_SCROLLBAR, null, true);
		
	}
	
	private void btnClearWidgetSelected(SelectionEvent evt) {
		event.clearRegions();
		//clear all evaluators by iterating over the osc addresses of the event set
		for(String address: event.getEventSet().getOscAddresses()) {
			event.getEvaluator(address).clear();
		}
		
	}
	
	private void txtKeyModifyText(ModifyEvent evt) {
		event.setKey(txtKey.getText());
	}
	
	private void txtNameModifyText(ModifyEvent evt) {
		event.setName(txtName.getText());
	}
	
	private void comboOscOutAddressWidgetSelected(SelectionEvent evt) {
		if(!comboOscOutAddress.getItem(comboOscOutAddress.getSelectionIndex()).equals("None")) {
			event.setKey(comboOscOutAddress.getItem(comboOscOutAddress.getSelectionIndex()));
			event.getEventSet().setModified(true);
		} else {	
			event.setKey(null); 
		}
			
		
	}

}
