package edu.stanford.hci.exemplar.widgets;
import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;
import java.util.List;

import org.eclipse.swt.SWT;
import org.eclipse.swt.custom.ScrolledComposite;
import org.eclipse.swt.events.PaintEvent;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.graphics.Rectangle;
import org.eclipse.swt.layout.FillLayout;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Group;
import org.eclipse.swt.widgets.Shell;

import com.cloudgarden.resource.SWTResourceManager;

import edu.stanford.hci.exemplar.Activator;
import edu.stanford.hci.exemplar.Event;
import edu.stanford.hci.exemplar.EventSet;
import edu.stanford.hci.exemplar.ExemplarConstants;

/**
* This code was edited or generated using CloudGarden's Jigloo
* SWT/Swing GUI Builder, which is free for non-commercial
* use. If Jigloo is being used commercially (ie, by a corporation,
* company or business for any purpose whatever) then you
* should purchase a license for each developer using Jigloo.
* Please visit www.cloudgarden.com for details.
* Use of Jigloo implies acceptance of these licensing terms.
* A COMMERCIAL LICENSE HAS NOT BEEN PURCHASED FOR
* THIS MACHINE, SO JIGLOO OR THIS CODE CANNOT BE USED
* LEGALLY FOR ANY CORPORATE OR COMMERCIAL PURPOSE.
*/
/**
 * Exemplar
 * Copyright (c) 2004-2007, Stanford University
 * All rights reserved.
 *
 * <p>
 * This software is distributed under the <a href="http://hci.stanford.edu/research/copyright.txt">
 * BSD License</a>.
 * </p>
 * 
 * 
 * @author <a href="http://bjoern.org/">Bjoern Hartmann</a> ( bjoern(AT)stanford.edu )
 * @author Leith Abdulla
 */
public class EventSetComposite extends org.eclipse.swt.widgets.Composite implements PropertyChangeListener {

	{
		//Register as a resource user - SWTResourceManager will
		//handle the obtaining and disposing of resources
		SWTResourceManager.registerResourceUser(this);
	}

	private Composite setGroup;
	
	private Button btnAdd;
	private Composite c2;
	private Composite c1;
	private ScrolledComposite sc1;
	private EventSet eventSet; //link to Model; 

	/**
	* Auto-generated main method to display this 
	* org.eclipse.swt.widgets.Composite inside a new Shell.
	*/
	public static void main(String[] args) {
		showGUI();
	}
		
	/**
	* Auto-generated method to display this 
	* org.eclipse.swt.widgets.Composite inside a new Shell.
	*/
	public static void showGUI() {
		Display display = Display.getDefault();
		Shell shell = new Shell(display);
		EventSetComposite inst = new EventSetComposite(shell, SWT.NULL);
		Point size = inst.getSize();
		shell.setLayout(new FillLayout());
		shell.layout();
		if(size.x == 0 && size.y == 0) {
			inst.pack();
			shell.pack();
		} else {
			Rectangle shellBounds = shell.computeTrim(0, 0, size.x, size.y);
			shell.setSize(shellBounds.width, shellBounds.height);
		}
		shell.open();
		while (!shell.isDisposed()) {
			if (!display.readAndDispatch())
				display.sleep();
		}
	}

	public EventSetComposite(org.eclipse.swt.widgets.Composite parent, int style) {
		super(parent, style);
		this.eventSet = null;
		initGUI();
		
	}

	public EventSetComposite(org.eclipse.swt.widgets.Composite parent, int style, EventSet eventSet) {
		super(parent, style);
		this.eventSet = eventSet;
		initGUI();
		
	}

	private void initGUI() {
		try {
		
			GridLayout thisLayout = new GridLayout();
			thisLayout.makeColumnsEqualWidth = true;
			this.setLayout(thisLayout);
			this.setLayoutData(null);
			{
				/*setGroup = new Group(this, SWT.NONE);
				GridLayout setGroupLayout = new GridLayout();
				setGroupLayout.makeColumnsEqualWidth = true;
				setGroupLayout.verticalSpacing = 2;
				setGroupLayout.marginHeight = 2;
				setGroupLayout.marginWidth = 2;
				setGroupLayout.horizontalSpacing = 2;
				
				setGroup.setLayout(setGroupLayout);
				GridData group4LData = new GridData();
				group4LData.widthHint = 300;
				group4LData.heightHint = 300;
				group4LData.grabExcessHorizontalSpace = true;
				group4LData.grabExcessVerticalSpace = true;
				group4LData.verticalAlignment = GridData.BEGINNING;
				setGroup.setLayoutData(group4LData); */
				{
					sc1 = new ScrolledComposite(this, SWT.H_SCROLL
						| SWT.V_SCROLL);
					

					GridData sc1LData = new GridData();
					sc1LData.widthHint = 290;
					sc1LData.grabExcessHorizontalSpace = true;
					sc1LData.heightHint = 250;
					sc1LData.verticalAlignment = GridData.BEGINNING;
					sc1.setLayoutData(sc1LData);
					sc1.setBackground(SWTResourceManager.getColor(255, 255, 255));
					{
						c1 = new Composite(sc1, SWT.NONE);
						GridLayout c1Layout = new GridLayout();
						c1Layout.makeColumnsEqualWidth = true;
						c1Layout.marginHeight = 2;
						c1Layout.marginWidth = 0;
						c1Layout.verticalSpacing = 2;
						c1.setLayout(c1Layout);
						sc1.setContent(c1);
						c1.setBackground(SWTResourceManager.getColor(255, 255, 255));
						addEvent();
						
					}
				}
				{
					c2 = new Composite(this, SWT.NONE);
					GridLayout c2Layout = new GridLayout();
					c2Layout.makeColumnsEqualWidth = true;
					GridData c2LData = new GridData();
					c2LData.grabExcessHorizontalSpace = true;
					c2.setLayoutData(c2LData);
					c2.setLayout(c2Layout);
					{
						btnAdd = new Button(c2, SWT.PUSH | SWT.CENTER);
						btnAdd.setText("Add");
						GridData btnAddLData = new GridData();
						btnAddLData.widthHint = 31;
						btnAddLData.heightHint = 15;
						btnAdd.setLayoutData(btnAddLData);
						btnAdd.setSize(31, 15);
						btnAdd.addSelectionListener(new SelectionAdapter() {
							public void widgetSelected(SelectionEvent evt) {
								btnAddWidgetSelected(evt);
							}
						});
					}
				}

			}

			this.layout();
		} catch (Exception e) {
			e.printStackTrace();
		}
		Activator.getDefault().pcs.addPropertyChangeListener(ExemplarConstants.PROP_UPDATE_SCROLLBAR, this);
		Activator.getDefault().pcs.addPropertyChangeListener(ExemplarConstants.PROP_REPLACE_EVENT_SET_MODEL, this);
		Activator.getDefault().pcs.addPropertyChangeListener(ExemplarConstants.PROP_ADD_EVENT_IN_UI,this);
		
	}

	protected void paintControl(PaintEvent evt) {
		// TODO Auto-generated method stub
		
	}
	public void addButton() {
		  Button button = new Button(c1, SWT.PUSH);
		  button.setText("Auto-created");
		  //compute c1 size:
		  recomputeScrollSize();
		  
	}
	protected void recomputeScrollSize() {
		if(c1.getChildren()!=null) {
		  int w=0;
	  	  int h=0;
		  for(int i=0; i<c1.getChildren().length; i++) {
			  if(!c1.getChildren()[i].isDisposed()) {
				  Point p=c1.getChildren()[i].computeSize(SWT.DEFAULT,SWT.DEFAULT);
				  w=Math.max(p.x,w);
				  h+=p.y+10;
			  }
		  }
		  c1.setSize(w, h);
		  c1.pack(true);
		  c1.layout(true);
		  
	  }
		
	}

	public void addEvent() {
		Event e= eventSet.addEvent();
		EventComposite ec = new EventComposite(c1, SWT.NONE);
		ec.setEvent(e);
		recomputeScrollSize();
	}

	/**
	 * call from de-serialization routine
	 * @param es eventset that is being de-serialized
	 */
	public void replaceEventSet(EventSet es) {
		// destroy all existing events
		for(Control c: c1.getChildren()) {
			if(c instanceof EventComposite) {
				((EventComposite) c).btnCloseWidgetSelected(null);
			}
		
		}
		//swap the new set in
		eventSet = es;
		for(Event e: eventSet.events) {
			EventComposite ec = new EventComposite(c1, SWT.NONE);
			ec.setEvent(e);
			recomputeScrollSize();
		}
	}

	private void btnAddWidgetSelected(SelectionEvent evt) {
		//addButton();
		addEvent();
	}

	public EventSet getEventSet() {
		return eventSet;
	}

	public void setEventSet(EventSet eventSet) {
		this.eventSet = eventSet;
	}

	public void propertyChange(PropertyChangeEvent evt) {
		if(evt.getPropertyName().equals(ExemplarConstants.PROP_UPDATE_SCROLLBAR)) {
			recomputeScrollSize();
		}
		else if(evt.getPropertyName().equals(ExemplarConstants.PROP_REPLACE_EVENT_SET_MODEL)) {
			if(eventSet.getOscAddresses().equals((List<String>)evt.getOldValue())) {
				replaceEventSet((EventSet)evt.getNewValue());
			}
		}
		else if(evt.getPropertyName().equals(ExemplarConstants.PROP_ADD_EVENT_IN_UI)) {
			//only add an event if the message was meant for us
			if(((List<String>)evt.getNewValue()).equals(eventSet.getOscAddresses())) {
				addEvent();
			}
		}
	}

}
