package edu.stanford.hci.exemplar.widgets;
import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.eclipse.swt.SWT;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.ExpandBar;
import org.eclipse.swt.widgets.ExpandItem;

import com.cloudgarden.resource.SWTResourceManager;

import edu.stanford.hci.exemplar.Activator;
import edu.stanford.hci.exemplar.ExemplarConstants;


/**
* This code was edited or generated using CloudGarden's Jigloo
* SWT/Swing GUI Builder, which is free for non-commercial
* use. If Jigloo is being used commercially (ie, by a corporation,
* company or business for any purpose whatever) then you
* should purchase a license for each developer using Jigloo.
* Please visit www.cloudgarden.com for details.
* Use of Jigloo implies acceptance of these licensing terms.
* A COMMERCIAL LICENSE HAS NOT BEEN PURCHASED FOR
* THIS MACHINE, SO JIGLOO OR THIS CODE CANNOT BE USED
* LEGALLY FOR ANY CORPORATE OR COMMERCIAL PURPOSE.
*/
/**
 * Exemplar
 * Copyright (c) 2004-2007, Stanford University
 * All rights reserved.
 *
 * <p>
 * This software is distributed under the <a href="http://hci.stanford.edu/research/copyright.txt">
 * BSD License</a>.
 * </p>
 * 
 * 
 * @author <a href="http://bjoern.org/">Bjoern Hartmann</a> ( bjoern(AT)stanford.edu )
 * @author Leith Abdulla
 */
public class EventSetExpandBar extends Composite implements PropertyChangeListener {
	private ExpandBar bar;
	private final Map <List<String>,ExpandItem> map = new HashMap<List<String>,ExpandItem>();
	public EventSetExpandBar(Composite parent, int style) {
		super(parent, style);
		initGUI();
		if(Activator.getDefault()!=null)
			Activator.getDefault().pcs.addPropertyChangeListener(ExemplarConstants.PROP_SENSOR_UPDATE,this);
	}
	
	private void initGUI() {
		try {
			{
				bar = new ExpandBar(this, SWT.V_SCROLL);
				bar.setBackground(SWTResourceManager.getColor(212,208,200));
				bar.setForeground(SWTResourceManager.getColor(0,0,0));
				addItem("/adc0",true);
				bar.setSpacing(4);
				bar.setBounds(0, 0, 320, 320);
			}
			
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	private void addItem(String address, boolean expanded) {
		//generate a one-item list and pass through to addItem(List<String>...)
		List<String> tempList = new ArrayList<String>();
		tempList.add(address);
		addItem(tempList,expanded);
	}

	private void addItem(List<String> addresses, boolean expanded) {
			EventSetComposite evc = new EventSetComposite(
					bar,
					SWT.NONE,Activator.getDefault().getEventSetForOscAddressList(addresses));
			ExpandItem item0 = new ExpandItem (bar, SWT.NONE, 0);
			item0.setText(buildString(addresses));
			item0.setHeight(evc.computeSize(SWT.DEFAULT, SWT.DEFAULT).y);
			item0.setControl(evc);
			item0.setExpanded(expanded);
			map.put(addresses, item0);
	}

	private String buildString(List<String> addresses) {
		String s = "Events for ";
		for(String a: addresses) {
			s = s.concat(a).concat(" ");
		}
		return s;
	}



	public void propertyChange(PropertyChangeEvent evt) {
		if(ExemplarConstants.PROP_SENSOR_UPDATE.equals(evt.getPropertyName())) {
			//contract everything
			for(Map.Entry<List<String>, ExpandItem> entry:map.entrySet()) {
				entry.getValue().setExpanded(false);
				
				
			}
			//if we have defined events for this before
			if(map.containsKey(Activator.getDefault().getActiveSensors())) {
				//open it
				map.get(Activator.getDefault().getActiveSensors()).setExpanded(true);
				
			} else  {
				//new sensor combo:
				//generate an EventSet for them
				Activator.getDefault().createEventSetForOscAddressList(Activator.getDefault().getActiveSensors());
				//and generate a new ExpandItem for it
				addItem(Activator.getDefault().getActiveSensors(),true);
				
			}
		}		
	}
}
