package edu.stanford.hci.exemplar.widgets;

import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;
import java.util.Vector;

import org.eclipse.swt.SWT;
import org.eclipse.swt.events.ExpandAdapter;
import org.eclipse.swt.events.ExpandEvent;
import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.graphics.Rectangle;
import org.eclipse.swt.layout.FillLayout;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.ExpandBar;
import org.eclipse.swt.widgets.ExpandItem;
import org.eclipse.swt.widgets.Group;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Shell;

import edu.stanford.hci.exemplar.Activator;
import edu.stanford.hci.exemplar.ExemplarConstants;
import edu.stanford.hci.exemplar.FilterEntry;
import edu.stanford.hci.exemplar.FilterType;
import edu.stanford.hci.exemplar.Sensor;
import edu.stanford.hci.exemplar.exensions.CustomFilter1;
import edu.stanford.hci.exemplar.exensions.CustomFilter2;
import edu.stanford.hci.exemplar.exensions.FilterExtension;
import edu.stanford.hci.exemplar.exensions.FilterExtensionLoader;


/**
* This code was edited or generated using CloudGarden's Jigloo
* SWT/Swing GUI Builder, which is free for non-commercial
* use. If Jigloo is being used commercially (ie, by a corporation,
* company or business for any purpose whatever) then you
* should purchase a license for each developer using Jigloo.
* Please visit www.cloudgarden.com for details.
* Use of Jigloo implies acceptance of these licensing terms.
* A COMMERCIAL LICENSE HAS NOT BEEN PURCHASED FOR
* THIS MACHINE, SO JIGLOO OR THIS CODE CANNOT BE USED
* LEGALLY FOR ANY CORPORATE OR COMMERCIAL PURPOSE.
*/
/**
 * Exemplar
 * Copyright (c) 2004-2007, Stanford University
 * All rights reserved.
 *
 * <p>
 * This software is distributed under the <a href="http://hci.stanford.edu/research/copyright.txt">
 * BSD License</a>.
 * </p>
 * 
 * 
 * @author <a href="http://bjoern.org/">Bjoern Hartmann</a> ( bjoern(AT)stanford.edu )
 * @author Leith Abdulla
 */
public class FilterSetComposite extends Composite implements PropertyChangeListener {
	private Composite filterComposite;
	private ExpandBar bar;
	private Button btnAdd;
	private Label label1;
	final Image imgCheck = Activator.getImageDescriptor("icons/check.png").createImage(true);
	final Image imgX = Activator.getImageDescriptor("icons/x.png").createImage(true);
	
	/**
	* Auto-generated main method to display this 
	* org.eclipse.swt.widgets.Composite inside a new Shell.
	*/
	public static void main(String[] args) {
		showGUI();
	}
		
	/**
	* Auto-generated method to display this 
	* org.eclipse.swt.widgets.Composite inside a new Shell.
	*/
	public static void showGUI() {
		Display display = Display.getDefault();
		Shell shell = new Shell(display);
		FilterSetComposite inst = new FilterSetComposite(shell, SWT.NULL);
		Point size = inst.getSize();
		shell.setLayout(new FillLayout());
		shell.layout();
		if(size.x == 0 && size.y == 0) {
			inst.pack();
			shell.pack();
		} else {
			Rectangle shellBounds = shell.computeTrim(0, 0, size.x, size.y);
			shell.setSize(shellBounds.width, shellBounds.height);
		}
		shell.open();
		while (!shell.isDisposed()) {
			if (!display.readAndDispatch())
				display.sleep();
		}
	}

	public FilterSetComposite(Composite parent, int style) {
		super(parent, style);
		initGUI();
		Activator.getDefault().pcs.addPropertyChangeListener(ExemplarConstants.PROP_MOVE_FILTER_UP,this);
		Activator.getDefault().pcs.addPropertyChangeListener(ExemplarConstants.PROP_MOVE_FILTER_DOWN,this);
		Activator.getDefault().pcs.addPropertyChangeListener(ExemplarConstants.PROP_SENSOR_UPDATE, this);
		Activator.getDefault().pcs.addPropertyChangeListener(ExemplarConstants.PROP_ACTIVE_SENSOR_UPDATE, this);
	}

	private void initGUI() {
		try {
			{

			}
			GridLayout thisLayout = new GridLayout();
			thisLayout.makeColumnsEqualWidth = true;
			thisLayout.marginHeight = 0;
			thisLayout.marginWidth = 0;
			thisLayout.verticalSpacing = 0;
			thisLayout.horizontalSpacing = 0;
			this.setLayout(thisLayout);
			
			{
				//label1 = new Label(this, SWT.NONE);
				//label1.setText("Filters for active sensor..."); //should dynamically change
				
			}
			{
				bar = new ExpandBar(this, SWT.V_SCROLL);
				//bar.setBackground(SWTResourceManager.getColor(212,208,200));
				//bar.setForeground(SWTResourceManager.getColor(0,0,0));
				addItem(new FilterEntry(FilterType.SMOOTHE,false));
				addItem(new FilterEntry(FilterType.DIFF,false));
				addItem(new FilterEntry(FilterType.SCALE,false));
				addItem(new FilterEntry(FilterType.OFFSET,false));
				for(Class cls: FilterExtensionLoader.getInstance().getFilterList()) {
					addItem(new FilterEntry(FilterType.USERDEFINED,false,cls));
				}
				//addItem(new FilterEntry(FilterType.USERDEFINED,false,CustomFilter1.class));
				//addItem(new FilterEntry(FilterType.USERDEFINED,false,CustomFilter2.class));
				//addItem(FilterType.MAP,false);
				bar.setSpacing(4);
				bar.addExpandListener(new ExpandAdapter() {
					public void itemCollapsed(ExpandEvent evt) {
						barItemCollapsed(evt);
					}
					public void itemExpanded(ExpandEvent evt) {
						barItemExpanded(evt);
					}
				});
				GridData barLData = new GridData();
				barLData.widthHint = 200;
				barLData.heightHint = 300;
				bar.setLayoutData(barLData);
				//bar.setBounds(0, 0, 300, 300);
			}
			/*{
				btnAdd = new Button(this, SWT.PUSH | SWT.CENTER);
				btnAdd.setText("Add Filter");
			}*/
			this.layout();
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	private void addItem(FilterEntry entry) {
		Composite filterComposite=null;
		ExpandItem item0 = new ExpandItem (bar, SWT.NONE, 0);
		if(FilterType.DIFF.equals(entry.type)) {
			filterComposite = new DiffFilterComposite(
					bar,
					SWT.NONE);
			
			item0.setText("Rate of Change");
		} else if (FilterType.SMOOTHE.equals(entry.type)) {
			filterComposite = new SmootheFilterComposite(
					bar,
					SWT.NONE);
			item0.setText("Smooth");
			
		} else if (FilterType.SCALE.equals(entry.type)) {
			filterComposite = new ScaleFilterComposite(
				bar,
				SWT.NONE);
			item0.setText("Scale Y-Axis");
		}else if (FilterType.OFFSET.equals(entry.type)) {
			filterComposite = new OffsetFilterComposite(
				bar,
				SWT.NONE);
			item0.setText("Offset");
		}else if (FilterType.MAP.equals(entry.type)) {
			filterComposite = new MapFilterComposite(
					bar,
					SWT.NONE);
				item0.setText("Mapping");
		}else if (FilterType.USERDEFINED.equals(entry.type)) {
			Sensor sensor = Activator.getDefault().getSingleActiveSensor();
			FilterExtension f =FilterExtensionLoader.getInstance().getFilter(sensor, entry.detail);
			
			filterComposite = new UserFilterComposite(
					bar,
					SWT.NONE,f.getDescription());
			
			if(f!=null) {
				item0.setText(f.getName());
			}
		}
		item0.setData("type", entry.type);
		item0.setData("detail",entry.detail);
		item0.setHeight(filterComposite.computeSize(SWT.DEFAULT, SWT.DEFAULT).y);
		item0.setControl(filterComposite);
		setActive(item0, entry.active);
		
				
	}
	
	private void barItemExpanded(ExpandEvent evt) {
		((ExpandItem)evt.item).setImage(imgCheck);
		Sensor s = Activator.getDefault().getSingleActiveSensor();
		if(s!=null) {
			Vector<FilterEntry> v = new Vector<FilterEntry>();
			for(ExpandItem item:bar.getItems()) {
				if(item.getExpanded() || item.equals(evt.item)) {
					v.add(new FilterEntry((FilterType)item.getData("type"),true,(Class)item.getData("detail")));
				} else {
					v.add(new FilterEntry((FilterType)item.getData("type"),false,(Class)item.getData("detail")));
				}
			}
			s.setActiveFilterVector(v);
		}
		
	}


	private void barItemCollapsed(ExpandEvent evt) {
		((ExpandItem)evt.item).setImage(imgX);
		Sensor s = Activator.getDefault().getSingleActiveSensor();
		if(s!=null) {
			Vector<FilterEntry> v = new Vector<FilterEntry>();
			for(ExpandItem item:bar.getItems()) {
				if(item.getExpanded() && !item.equals(evt.item)) {
					v.add(new FilterEntry((FilterType)item.getData("type"),true,(Class)item.getData("detail")));
				} else {
					v.add(new FilterEntry((FilterType)item.getData("type"),false,(Class)item.getData("detail")));
				}
					
			}
			s.setActiveFilterVector(v);
		}
	}

	private void updateSensorFilterVector() {
		Sensor s = Activator.getDefault().getSingleActiveSensor();
		if(s!=null) {
			s.setActiveFilterVector(buildFilterVector());
		}
	}
	
	
	private Vector<FilterEntry> buildFilterVector () {
		Vector<FilterEntry> v = new Vector<FilterEntry>();
		for(ExpandItem item:bar.getItems()) {
			if(item.getExpanded()) {
				v.add(new FilterEntry((FilterType)item.getData("type"),true,(Class)item.getData("detail")));
			} else {
				v.add(new FilterEntry((FilterType)item.getData("type"),false,(Class)item.getData("detail")));
			}
		}
		return v;
	}

	public void moveItemUp(Control ctrl) {
		//find the item of the control that generated the request
		ExpandItem item=null;
		ExpandItem lastItem=null;
		for(ExpandItem tempItem:bar.getItems()) {
			if(tempItem.getControl().equals(ctrl)) {
				item=tempItem;
				break;
			}
			lastItem=tempItem;
		}
		if(lastItem!=null) {
			swapItems(lastItem,item);
		}

		this.pack(true);
		this.layout(true);
		updateSensorFilterVector();
	}
	
	private void moveItemDown(Control ctrl) {
		//find the item of the control that generated the request
		ExpandItem item=null;
		ExpandItem nextItem=null;
		boolean breakNext=false;
		for(ExpandItem tempItem:bar.getItems()) {
			// found a match in the previous iteration, so break
			if(breakNext) {
				nextItem=tempItem;
				break;
			}
			// if we mach, the next item in the list is the one we want to swap with
			if(tempItem.getControl().equals(ctrl)) {
				item=tempItem;
				breakNext=true;
			}
			
		}
		if(nextItem!=null) {
			swapItems(nextItem,item);
		}
		this.pack(true);
		this.layout(true);
		updateSensorFilterVector();
	}

	/**
	 * Swap the order of two ExpandItems.
	 * Since there is no support for swapping the items directly, this method leaves the items in place, 
	 * but swaps their content and data one-by-one.
	 * @param item1
	 * @param item2
	 */
	private void swapItems(ExpandItem item1, ExpandItem item2) {
		if(item1==null || item2==null) {
			return;
		}
		//swap controls
		Control tempCtrl = item1.getControl();
		item1.setControl(item2.getControl());
		item2.setControl(tempCtrl);
		//swap text
		String tempString =item1.getText();
		item1.setText(item2.getText());
		item2.setText(tempString);
		//swap data
		Object tempData = item1.getData("type");
		item1.setData("type",item2.getData("type"));
		item2.setData("type",tempData);
		
		tempData = item1.getData("detail");
		item1.setData("detail",item2.getData("detail"));
		item2.setData("detail",tempData);
		//swap expanded
		boolean tempExp = item1.getExpanded();
		item1.setExpanded(item2.getExpanded());
		item2.setExpanded(tempExp);
		//swap images
		Image tempImg = item1.getImage();
		item1.setImage(item2.getImage());
		item2.setImage(tempImg);
		//swap heights
		int tempHeight = item1.getHeight();
		item1.setHeight(item2.getHeight());
		item2.setHeight(tempHeight);
	}

	public void propertyChange(PropertyChangeEvent evt) {
		if(ExemplarConstants.PROP_MOVE_FILTER_UP.equals(evt.getPropertyName())) {
			moveItemUp((Composite)evt.getNewValue());
		} else if(ExemplarConstants.PROP_MOVE_FILTER_DOWN.equals(evt.getPropertyName())) {
			moveItemDown((Composite)evt.getNewValue());
		} else if(ExemplarConstants.PROP_SENSOR_UPDATE.equals(evt.getPropertyName())){
			updateGuiFromSensor();
			//update all fields of all filter for the newly selected sensor
		} else if(ExemplarConstants.PROP_ACTIVE_SENSOR_UPDATE.equals(evt.getPropertyName()))
		{
			updateGuiFromSensor();
		}
	}
	
	private void updateGuiFromSensor() {
		Sensor s = Activator.getDefault().getSingleActiveSensor();
		
		if(s!=null) {
			((Group) this.getParent()).setText("Filter for " + s.getOSCAddress());
			
			// new sensor
			// load values 
			for(ExpandItem item:bar.getItems()) {
				if(item.getData("type").equals(FilterType.DIFF)) {
					//nothing to do
				} else if (item.getData("type").equals(FilterType.OFFSET)) {
					((OffsetFilterComposite)item.getControl()).setScale(s.getOffset());
					
				} else if (item.getData("type").equals(FilterType.SCALE)) {
					((ScaleFilterComposite)item.getControl()).setScale(s.getScaleFactor());
					((ScaleFilterComposite)item.getControl()).setScaleBaselise(s.getScaleBaseline());
				} else if (item.getData("type").equals(FilterType.SMOOTHE)) {
					((SmootheFilterComposite)item.getControl()).setScale(s.getSmoothe());
				} else if (item.getData("type").equals(FilterType.MAP)) {
					//TODO
				} else if (item.getData("type").equals(FilterType.USERDEFINED)) {
					//nothing to do
				}
				
			}
			// get items into correct order
			// construct two lists: l1: controls in desired order, and l2: controls in current order.
			Vector<FilterEntry> vSensor = s.getActiveFilterVector();
			Vector<FilterEntry> vBar = buildFilterVector();
			for(int i=0; i<vSensor.size(); i++) {
				if((vSensor.get(i).type==vBar.get(i).type) && (vSensor.get(i).detail==vBar.get(i).detail)) {
					;
				} else {
					//swap items that are in the wrong order
					swapItems(bar.getItem(i), findItemForFilterType(vSensor.get(i).type,vSensor.get(i).detail,i+1));
					vBar = buildFilterVector();
				}
				
				//set expanded state and image
				setActive(bar.getItem(i), vSensor.get(i).active);
				
			}
		} else {
			//no sensor - close all
			for(ExpandItem tempItem:bar.getItems()) {
				tempItem.setExpanded(false);
			}
		}
	}
	
	private ExpandItem findItemForFilterType(FilterType t,Class detail, int startAt) {
		for(int i=startAt; i<bar.getItemCount(); i++) {
			ExpandItem item = bar.getItem(i);
			if(t.equals(item.getData("type")) && detail == item.getData("detail")) {
				return item;
			}
		}
		return null;
	}

	private void setActive(ExpandItem item, boolean active) {
		item.setExpanded(active);
		if(active)
			item.setImage(imgCheck);
		else
			item.setImage(imgX);
	}
}

