package edu.stanford.hci.exemplar.widgets;
import org.eclipse.swt.SWT;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.graphics.Rectangle;
import org.eclipse.swt.layout.FillLayout;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Control;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Shell;

import com.cloudgarden.resource.SWTResourceManager;

import edu.stanford.hci.exemplar.Activator;
import edu.stanford.hci.exemplar.ExemplarConstants;


/**
* This code was edited or generated using CloudGarden's Jigloo
* SWT/Swing GUI Builder, which is free for non-commercial
* use. If Jigloo is being used commercially (ie, by a corporation,
* company or business for any purpose whatever) then you
* should purchase a license for each developer using Jigloo.
* Please visit www.cloudgarden.com for details.
* Use of Jigloo implies acceptance of these licensing terms.
* A COMMERCIAL LICENSE HAS NOT BEEN PURCHASED FOR
* THIS MACHINE, SO JIGLOO OR THIS CODE CANNOT BE USED
* LEGALLY FOR ANY CORPORATE OR COMMERCIAL PURPOSE.
*/
/**
 * Exemplar
 * Copyright (c) 2004-2007, Stanford University
 * All rights reserved.
 *
 * <p>
 * This software is distributed under the <a href="http://hci.stanford.edu/research/copyright.txt">
 * BSD License</a>.
 * </p>
 * 
 * 
 * @author <a href="http://bjoern.org/">Bjoern Hartmann</a> ( bjoern(AT)stanford.edu )
 * @author Leith Abdulla
 */
public class MoveButtonComposite extends org.eclipse.swt.widgets.Composite {

	{
		//Register as a resource user - SWTResourceManager will
		//handle the obtaining and disposing of resources
		SWTResourceManager.registerResourceUser(this);
	}

	private Button btnUp;
	private Button btnDown;
	

	/**
	* Auto-generated main method to display this 
	* org.eclipse.swt.widgets.Composite inside a new Shell.
	*/
	public static void main(String[] args) {
		showGUI();
	}
		
	/**
	* Auto-generated method to display this 
	* org.eclipse.swt.widgets.Composite inside a new Shell.
	*/
	public static void showGUI() {
		Display display = Display.getDefault();
		Shell shell = new Shell(display);
		MoveButtonComposite inst = new MoveButtonComposite(shell, SWT.NULL);
		Point size = inst.getSize();
		shell.setLayout(new FillLayout());
		shell.layout();
		if(size.x == 0 && size.y == 0) {
			inst.pack();
			shell.pack();
		} else {
			Rectangle shellBounds = shell.computeTrim(0, 0, size.x, size.y);
			shell.setSize(shellBounds.width, shellBounds.height);
		}
		shell.open();
		while (!shell.isDisposed()) {
			if (!display.readAndDispatch())
				display.sleep();
		}
	}

	public MoveButtonComposite(org.eclipse.swt.widgets.Composite parent, int style) {
		super(parent, style);
		initGUI();
	}


	private void initGUI() {
		try {
			{

			}
			GridLayout thisLayout = new GridLayout();
			thisLayout.makeColumnsEqualWidth = true;
			thisLayout.marginWidth = 0;
			thisLayout.marginHeight = 0;
			thisLayout.verticalSpacing = 1;
			this.setLayout(thisLayout);
			{
				btnUp = new Button(this, SWT.PUSH | SWT.CENTER);
				btnUp.setImage(Activator.getImageDescriptor("icons/uparrow.png").createImage());
				GridData btnUpLData = new GridData();
				btnUpLData.widthHint = 17;
				btnUpLData.heightHint = 17;
				btnUp.setLayoutData(btnUpLData);
				btnUp.setSize(17, 17);
				btnUp.addSelectionListener(new SelectionAdapter() {
					public void widgetSelected(SelectionEvent evt) {
						btnUpWidgetSelected(evt);
					}
				});
			}
			{
				btnDown = new Button(this, SWT.PUSH | SWT.CENTER);
				btnDown.setImage(Activator.getImageDescriptor("icons/downarrow.png").createImage());
				GridData btnDownLData = new GridData();
				btnDownLData.widthHint = 17;
				btnDownLData.heightHint = 17;
				btnDown.setLayoutData(btnDownLData);
				btnDown.setSize(17, 17);
				btnDown.addSelectionListener(new SelectionAdapter() {
					public void widgetSelected(SelectionEvent evt) {
						btnDownWidgetSelected(evt);
					}
				});
			}
			this.layout();
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	protected void btnDownWidgetSelected(SelectionEvent evt) {
		Activator.getDefault().pcs.firePropertyChange(ExemplarConstants.PROP_MOVE_FILTER_DOWN, null,getParent());
		
	}

	protected void btnUpWidgetSelected(SelectionEvent evt) {
		Activator.getDefault().pcs.firePropertyChange(ExemplarConstants.PROP_MOVE_FILTER_UP, null,getParent());
		
	}

}
