package edu.stanford.hci.exemplar.widgets;

import org.eclipse.swt.SWT;
import org.eclipse.swt.events.MouseAdapter;
import org.eclipse.swt.events.MouseEvent;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.graphics.Rectangle;
import org.eclipse.swt.layout.FillLayout;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Scale;
import org.eclipse.swt.widgets.Shell;

import edu.stanford.hci.exemplar.Activator;
import edu.stanford.hci.exemplar.Sensor;

/**
* This code was edited or generated using CloudGarden's Jigloo
* SWT/Swing GUI Builder, which is free for non-commercial
* use. If Jigloo is being used commercially (ie, by a corporation,
* company or business for any purpose whatever) then you
* should purchase a license for each developer using Jigloo.
* Please visit www.cloudgarden.com for details.
* Use of Jigloo implies acceptance of these licensing terms.
* A COMMERCIAL LICENSE HAS NOT BEEN PURCHASED FOR
* THIS MACHINE, SO JIGLOO OR THIS CODE CANNOT BE USED
* LEGALLY FOR ANY CORPORATE OR COMMERCIAL PURPOSE.
*/
/**
 * Exemplar
 * Copyright (c) 2004-2007, Stanford University
 * All rights reserved.
 *
 * <p>
 * This software is distributed under the <a href="http://hci.stanford.edu/research/copyright.txt">
 * BSD License</a>.
 * </p>
 * 
 * 
 * @author <a href="http://bjoern.org/">Bjoern Hartmann</a> ( bjoern(AT)stanford.edu )
 * @author Leith Abdulla
 */
public class OffsetFilterComposite extends org.eclipse.swt.widgets.Composite {
	private Label label1;
	private Scale scale;
	private MoveButtonComposite moveButtonComposite;

	/**
	* Auto-generated main method to display this 
	* org.eclipse.swt.widgets.Composite inside a new Shell.
	*/
	public static void main(String[] args) {
		showGUI();
	}
		
	/**
	* Auto-generated method to display this 
	* org.eclipse.swt.widgets.Composite inside a new Shell.
	*/
	public static void showGUI() {
		Display display = Display.getDefault();
		Shell shell = new Shell(display);
		OffsetFilterComposite inst = new OffsetFilterComposite(shell, SWT.NULL);
		Point size = inst.getSize();
		shell.setLayout(new FillLayout());
		shell.layout();
		if(size.x == 0 && size.y == 0) {
			inst.pack();
			shell.pack();
		} else {
			Rectangle shellBounds = shell.computeTrim(0, 0, size.x, size.y);
			shell.setSize(shellBounds.width, shellBounds.height);
		}
		shell.open();
		while (!shell.isDisposed()) {
			if (!display.readAndDispatch())
				display.sleep();
		}
	}

	public OffsetFilterComposite(org.eclipse.swt.widgets.Composite parent, int style) {
		super(parent, style);
		initGUI();
	}

	private void initGUI() {
		try {
			GridLayout thisLayout = new GridLayout();
			this.setLayout(thisLayout);
			thisLayout.numColumns = 2;
			{
				label1 = new Label(this, SWT.NONE);
				label1.setText("Offset Value [-1..+1]");
			}
			{
				GridData moveButtonCompositeLData = new GridData();
				moveButtonCompositeLData.verticalSpan = 2;
				moveButtonComposite = new MoveButtonComposite(this, SWT.NONE);
				moveButtonComposite.setLayoutData(moveButtonCompositeLData);
			}
			{
				scale = new Scale(this, SWT.NONE);
				scale.setMaximum(20);
				scale.setPageIncrement(2);
				scale.setSelection(10);
				scale.addMouseListener(new MouseAdapter() {
					public void mouseUp(MouseEvent evt) {
						scaleMouseUp(evt);
					}
				});
				scale.addSelectionListener(new SelectionAdapter() {
					public void widgetSelected(SelectionEvent evt) {
						scaleWidgetSelected(evt);
					}
				});
			}
			this.layout();
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
	
	private void scaleWidgetSelected(SelectionEvent evt) {
		
		float offset = ((float)(scale.getSelection()-10))/10.f;
		Sensor s = Activator.getDefault().getSingleActiveSensor();
		if (s!=null) {
			s.setOffset(offset);
		}
	}
	public void setScale(float offset) {
		scale.setSelection((int)(10*offset+10));
	}
	
	private void scaleMouseUp(MouseEvent evt) {
		
		Activator.getDefault().eventSetRecalculate();
	}

}
