package edu.stanford.hci.exemplar.widgets;

import java.util.Collection;

import org.eclipse.swt.SWT;
import org.eclipse.swt.events.MouseAdapter;
import org.eclipse.swt.events.MouseEvent;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Combo;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Shell;

import edu.stanford.hci.exemplar.Activator;
import edu.stanford.hci.exemplar.Event;
import edu.stanford.hci.exemplar.EventSet;


/**
* This code was edited or generated using CloudGarden's Jigloo
* SWT/Swing GUI Builder, which is free for non-commercial
* use. If Jigloo is being used commercially (ie, by a corporation,
* company or business for any purpose whatever) then you
* should purchase a license for each developer using Jigloo.
* Please visit www.cloudgarden.com for details.
* Use of Jigloo implies acceptance of these licensing terms.
* A COMMERCIAL LICENSE HAS NOT BEEN PURCHASED FOR
* THIS MACHINE, SO JIGLOO OR THIS CODE CANNOT BE USED
* LEGALLY FOR ANY CORPORATE OR COMMERCIAL PURPOSE.
*/
/**
 * Exemplar
 * Copyright (c) 2004-2007, Stanford University
 * All rights reserved.
 *
 * <p>
 * This software is distributed under the <a href="http://hci.stanford.edu/research/copyright.txt">
 * BSD License</a>.
 * </p>
 * 
 * 
 * @author <a href="http://bjoern.org/">Bjoern Hartmann</a> ( bjoern(AT)stanford.edu )
 * @author Leith Abdulla
 */
public class SelectOneEventDialog extends org.eclipse.swt.widgets.Dialog {

	private Shell dialogShell;
	private Button buttonCancel;
	private Button buttonOk;
	private Combo eventCombo;
	private Label label1;
	private Event event;

	/**
	* Auto-generated main method to display this 
	* org.eclipse.swt.widgets.Dialog inside a new Shell.
	*/
	public static void main(String[] args) {
		try {
			Display display = Display.getDefault();
			Shell shell = new Shell(display);
			SelectOneEventDialog inst = new SelectOneEventDialog(shell, SWT.NULL);
			inst.open();
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	public SelectOneEventDialog(Shell parent, int style) {
		super(parent, style);
	}

	public Event open() {
		try {
			Shell parent = getParent();
			dialogShell = new Shell(parent, SWT.DIALOG_TRIM | SWT.APPLICATION_MODAL);

			GridLayout dialogShellLayout = new GridLayout();
			dialogShell.setLayout(dialogShellLayout);
			dialogShellLayout.numColumns = 2;
			dialogShell.layout();
			dialogShell.pack();
			dialogShell.setSize(226, 97);
			{
				label1 = new Label(dialogShell, SWT.NONE);
				label1.setText("Select Event:");
			}
			{
				GridData eventComboLData = new GridData();
				eventComboLData.widthHint = 109;
				eventComboLData.heightHint = 21;
				eventCombo = new Combo(dialogShell, SWT.NONE);
				eventCombo.setLayoutData(eventComboLData);
				//add string representations of each event
				for (EventSet set:Activator.getDefault().getEventSets()) {
					for(Event e:set.getEvents()) {
						String key = e.getName()+" ("+set.getOscAddressesAsString()+")";
						eventCombo.add(key);
						eventCombo.setData(key, e);
					}
				}
			}
			{
				buttonOk = new Button(dialogShell, SWT.PUSH | SWT.CENTER);
				GridData buttonOkLData = new GridData();
				buttonOkLData.horizontalAlignment = GridData.END;
				buttonOk.setLayoutData(buttonOkLData);
				buttonOk.setText("Ok");
				buttonOk.addMouseListener(new MouseAdapter() {
					public void mouseDown(MouseEvent evt) {
						buttonOkMouseDown(evt);
					}
				});
			}
			{
				buttonCancel = new Button(dialogShell, SWT.PUSH | SWT.CENTER);
				buttonCancel.setText("Cancel");
				buttonCancel.addMouseListener(new MouseAdapter() {
					public void mouseDown(MouseEvent evt) {
						buttonCancelMouseDown(evt);
					}
				});
			}
			dialogShell.open();
			Display display = dialogShell.getDisplay();
			while (!dialogShell.isDisposed()) {
				if (!display.readAndDispatch())
					display.sleep();
			}
		} catch (Exception e) {
			e.printStackTrace();
		}
		return event;
	}
	
	private void buttonOkMouseDown(MouseEvent evt) {
		int index = eventCombo.getSelectionIndex();
		if(index>=0) {
			event = (Event)eventCombo.getData(eventCombo.getItem(index));
		} else {
			event=null;
		}
		dialogShell.dispose();
	}
	
	private void buttonCancelMouseDown(MouseEvent evt) {
		event=null;
		dialogShell.dispose();
	}

}
