package edu.stanford.hci.exemplar.widgets;
import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;
import java.util.Iterator;
import java.util.List;

import org.eclipse.swt.SWT;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.graphics.Rectangle;
import org.eclipse.swt.layout.FillLayout;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Scale;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Slider;

import com.cloudgarden.resource.SWTResourceManager;

import edu.stanford.hci.exemplar.Activator;
import edu.stanford.hci.exemplar.BigViewModel;
import edu.stanford.hci.exemplar.EventRegion;
import edu.stanford.hci.exemplar.ExemplarConstants;
import edu.stanford.hci.exemplar.Sensor;
import edu.stanford.hci.exemplar.UserMouseToolMode;

/**
* This code was edited or generated using CloudGarden's Jigloo
* SWT/Swing GUI Builder, which is free for non-commercial
* use. If Jigloo is being used commercially (ie, by a corporation,
* company or business for any purpose whatever) then you
* should purchase a license for each developer using Jigloo.
* Please visit www.cloudgarden.com for details.
* Use of Jigloo implies acceptance of these licensing terms.
* A COMMERCIAL LICENSE HAS NOT BEEN PURCHASED FOR
* THIS MACHINE, SO JIGLOO OR THIS CODE CANNOT BE USED
* LEGALLY FOR ANY CORPORATE OR COMMERCIAL PURPOSE.
*/
/**
 * Exemplar
 * Copyright (c) 2004-2007, Stanford University
 * All rights reserved.
 *
 * <p>
 * This software is distributed under the <a href="http://hci.stanford.edu/research/copyright.txt">
 * BSD License</a>.
 * </p>
 * 
 * 
 * @author <a href="http://bjoern.org/">Bjoern Hartmann</a> ( bjoern(AT)stanford.edu )
 * @author Leith Abdulla
 */
public class SignalVizComposite extends Composite implements PropertyChangeListener {

	{
		//Register as a resource user - SWTResourceManager will
		//handle the obtaining and disposing of resources
		SWTResourceManager.registerResourceUser(this);
	}
	private Composite composite3;
	private Composite bigViewParent;
	//private Button btnClearBuffer;
	private Composite composite4;
	private Label label1;
	private Button btnDraw;
	private Button btnZoom;
	private Composite composite2;
	private Composite pauseBgComposite;
	private Button playPauseBtn;
	private Slider slider1;
	private Scale zoomScale;
	private Label label3;
	private boolean playing =true;
	protected int pausedLength;
	private UserMouseToolMode mouseMode;

	/**
	* Auto-generated main method to display this 
	* org.eclipse.swt.widgets.Composite inside a new Shell.
	*/
	public static void main(String[] args) {
		showGUI();
	}
		
	/**
	* Auto-generated method to display this 
	* org.eclipse.swt.widgets.Composite inside a new Shell.
	*/
	public static void showGUI() {
		Display display = Display.getDefault();
		Shell shell = new Shell(display);
		SignalVizComposite inst = new SignalVizComposite(shell, SWT.NULL);
		Point size = inst.getSize();
		shell.setLayout(new FillLayout());
		shell.layout();
		if(size.x == 0 && size.y == 0) {
			inst.pack();
			shell.pack();
		} else {
			Rectangle shellBounds = shell.computeTrim(0, 0, size.x, size.y);
			shell.setSize(shellBounds.width, shellBounds.height);
		}
		shell.open();
		while (!shell.isDisposed()) {
			if (!display.readAndDispatch())
				display.sleep();
		}
	}

	public SignalVizComposite(Composite parent, int style) {
		super(parent, style);
		
		mouseMode = UserMouseToolMode.DRAW;
		initGUI();
		//my custom code
		
		if(Activator.getDefault()!=null) {
			Activator.getDefault().pcs.addPropertyChangeListener(ExemplarConstants.PROP_REDRAW, this);
			Activator.getDefault().pcs.addPropertyChangeListener(ExemplarConstants.PROP_SENSOR_UPDATE, this);
			Activator.getDefault().pcs.addPropertyChangeListener(ExemplarConstants.PROP_MOUSE_DRAGGING, this);
			Activator.getDefault().pcs.addPropertyChangeListener(ExemplarConstants.PROP_SHOW_USER_REGION, this);
		}
	}
	
	

	private void initGUI() {
		try {
			{

			}
			GridLayout thisLayout = new GridLayout();
			thisLayout.makeColumnsEqualWidth = true;
			thisLayout.marginWidth = 0;
			thisLayout.horizontalSpacing = 0;
			this.setLayout(thisLayout);
			//this.setSize(610, 801);
			{
				
				composite3 = new Composite(this, SWT.NONE);
				GridLayout composite3Layout = new GridLayout();
				composite3Layout.numColumns = 5;
				composite3.setLayout(composite3Layout);
				GridData composite3LData = new GridData();
				composite3.setLayoutData(composite3LData);
				{
					label3 = new Label(composite3, SWT.NONE);
					label3.setText("Time scale:");
				}
				{
					zoomScale = new Scale(composite3, SWT.NONE);
					zoomScale.setSize(160, 16);
					zoomScale.setSelection(80);
					zoomScale.addSelectionListener(new SelectionAdapter() {
						public void widgetSelected(SelectionEvent evt) {
							zoomScaleWidgetSelected(evt);
						}
					});
				}
				{
					composite2 = new Composite(composite3, SWT.NONE);
					GridLayout composite2Layout = new GridLayout();
					composite2Layout.numColumns = 3;
					composite2.setLayout(composite2Layout);
					{
						label1 = new Label(composite2, SWT.NONE);
						label1.setText("Mouse mode:");
					}
					{
						btnZoom = new Button(composite2, SWT.RADIO | SWT.CENTER);
						btnZoom.setText("Drag");
						GridData btnZoomLData = new GridData();
						btnZoomLData.widthHint = 50;
						btnZoomLData.heightHint = 26;
						btnZoom.setLayoutData(btnZoomLData);
						btnZoom.addSelectionListener(new SelectionAdapter() {
							public void widgetSelected(SelectionEvent evt) {
								btnZoomWidgetSelected(evt);
							}
						});
					}
					{
						btnDraw = new Button(composite2, SWT.RADIO | SWT.CENTER);
						btnDraw.setText("Draw");
						btnDraw.setSelection(true);
						btnDraw.addSelectionListener(new SelectionAdapter() {
							public void widgetSelected(SelectionEvent evt) {
								btnDrawWidgetSelected(evt);
							}
						});
					}
				}
				{
					pauseBgComposite = new Composite(composite3, SWT.NONE);
					GridLayout composite1Layout = new GridLayout();
					composite1Layout.makeColumnsEqualWidth = true;
					GridData composite1LData = new GridData();
					composite1LData.heightHint = 33;
					composite1LData.horizontalAlignment = GridData.END;
					pauseBgComposite.setLayoutData(composite1LData);
					pauseBgComposite.setLayout(composite1Layout);
					{
						playPauseBtn = new Button(pauseBgComposite, SWT.TOGGLE
							| SWT.CENTER);
						playPauseBtn.setAlignment(SWT.CENTER);
						playPauseBtn.setText("Pause");
						GridData button5LData = new GridData();
						button5LData.horizontalAlignment = GridData.CENTER;
						button5LData.grabExcessHorizontalSpace = true;
						playPauseBtn.setLayoutData(button5LData);
						playPauseBtn
							.addSelectionListener(new SelectionAdapter() {
								public void widgetSelected(SelectionEvent evt) {
									playPauseBtnWidgetSelected(evt);
								}
							});
					}
				}
				{
					composite4 = new Composite(composite3, SWT.NONE);
					GridLayout composite4Layout = new GridLayout();
					composite4Layout.makeColumnsEqualWidth = true;
					GridData composite4LData = new GridData();
					composite4LData.grabExcessHorizontalSpace = true;
					composite4LData.horizontalAlignment = GridData.END;
					composite4.setLayoutData(composite4LData);
					composite4.setLayout(composite4Layout);
					/*{
						btnClearBuffer = new Button(composite4, SWT.PUSH
							| SWT.CENTER);
						btnClearBuffer.setText("Clear History");
						btnClearBuffer
							.addSelectionListener(new SelectionAdapter() {
							public void widgetSelected(SelectionEvent evt) {
								btnClearBufferWidgetSelected(evt);
							}
							});
					}*/
				}
			}
			{
				slider1 = new Slider(this, SWT.NONE);
				GridData slider1LData = new GridData();
				slider1LData.widthHint = 600;
				slider1LData.heightHint = 16;
				slider1.setLayoutData(slider1LData);
				slider1.setEnabled(!playing);
				slider1.addSelectionListener(new SelectionAdapter() {
					public void widgetSelected(SelectionEvent evt) {
						slider1WidgetSelected(evt);
					}
				});
			}
			{
				bigViewParent = new Composite(this, SWT.NONE);
				GridLayout composite4Layout = new GridLayout();
				composite4Layout.makeColumnsEqualWidth = true;
				composite4Layout.marginWidth = 0;
				composite4Layout.horizontalSpacing = 0;
				GridData bigViewParentLData = new GridData();
				//bigViewParentLData.grabExcessVerticalSpace = true;
				bigViewParentLData.horizontalAlignment = GridData.CENTER;
				bigViewParentLData.widthHint = 600;
				bigViewParentLData.heightHint = 723;
				bigViewParent.setLayoutData(bigViewParentLData);
				bigViewParent.setLayout(composite4Layout);
				//addBigViewCanvas();addBigViewCanvas();addBigViewCanvas();
				
			}
			Activator.getDefault().pcs.firePropertyChange(ExemplarConstants.PROP_USER_MOUSE_TOOL, null, mouseMode);
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
	
	protected void btnDrawWidgetSelected(SelectionEvent evt) {
		mouseMode =UserMouseToolMode.DRAW;
		Activator.getDefault().pcs.firePropertyChange(ExemplarConstants.PROP_USER_MOUSE_TOOL, null, mouseMode);
		
	}

	protected void btnZoomWidgetSelected(SelectionEvent evt) {
		mouseMode = UserMouseToolMode.DRAG;
		Activator.getDefault().pcs.firePropertyChange(ExemplarConstants.PROP_USER_MOUSE_TOOL, null, mouseMode);
		
	}

	private void addBigViewCanvas() {
		GridData bigViewWithButtonsComposite1LData = new GridData();
		//bigViewWithButtonsComposite1LData.grabExcessVerticalSpace = true;
		bigViewWithButtonsComposite1LData.horizontalAlignment = SWT.CENTER;
		bigViewWithButtonsComposite1LData.verticalAlignment = SWT.TOP;
		BigViewWithButtonsComposite bigViewWithButtonsComposite1 = new BigViewWithButtonsComposite(
				bigViewParent,
				SWT.DOUBLE_BUFFERED);
		
		GridData bigViewCanvasLData = new GridData();
		bigViewCanvasLData.horizontalAlignment = SWT.CENTER;
		bigViewCanvasLData.verticalAlignment = SWT.TOP;
		bigViewCanvasLData.widthHint = 600;
		bigViewCanvasLData.heightHint = 200;
		bigViewCanvasLData.grabExcessVerticalSpace = true;
		
		bigViewWithButtonsComposite1.setLayoutData(bigViewWithButtonsComposite1LData);
		bigViewWithButtonsComposite1.getBigViewCanvas().setLayoutData(bigViewCanvasLData);
		
		
	}

	private void resizeBigViewCanvas()
	{
		for(int i=0; i<bigViewParent.getChildren().length; i++) {
			
			BigViewWithButtonsComposite b = (BigViewWithButtonsComposite)bigViewParent.getChildren()[i];
			//b.getBigViewCanvas().setSize(400, 200/bigViewParent.getChildren().length);
			GridData bigViewCanvasLData = new GridData();
			bigViewCanvasLData.horizontalAlignment = SWT.CENTER;
			bigViewCanvasLData.verticalAlignment = SWT.TOP;
			bigViewCanvasLData.widthHint = 600;
			bigViewCanvasLData.grabExcessVerticalSpace = true;
			int dynamicHeight = (723-(bigViewParent.getChildren().length*40))/bigViewParent.getChildren().length; //TOOD: un-hardcode
			bigViewCanvasLData.heightHint = Math.min(300,dynamicHeight);
			
			
			GridData bigViewWithButtonsLData = new GridData();
			bigViewWithButtonsLData.horizontalAlignment = SWT.CENTER;
			bigViewWithButtonsLData.verticalAlignment = SWT.TOP;
			b.setLayoutData(bigViewWithButtonsLData );
			b.getBigViewCanvas().setLayoutData(bigViewCanvasLData);
		}
		
		bigViewParent.pack(true);
		bigViewParent.layout(true);
		this.getParent().getParent().getParent().layout(true); //= layout of ExemplarViewPart instance
	}
	
	private void zoomScaleWidgetSelected(SelectionEvent evt) {
		for(int i=0; i<bigViewParent.getChildren().length; i++) {
			BigViewWithButtonsComposite b = (BigViewWithButtonsComposite)bigViewParent.getChildren()[i];
			b.getModel().setZoom(zoomScale.getSelection());
			b.getBigViewCanvas().redraw();
		}
	}

	public void propertyChange(PropertyChangeEvent evt) {
	
		if(ExemplarConstants.PROP_SENSOR_UPDATE.equals(evt.getPropertyName())) {
			
			List<String> sensors = Activator.getDefault().getActiveSensors();
					
			if(bigViewParent.getChildren().length!= sensors.size())
			{
				while(bigViewParent.getChildren().length < sensors.size())
				{
					addBigViewCanvas();
				}
				while(bigViewParent.getChildren().length > sensors.size())
				{
					bigViewParent.getChildren()[bigViewParent.getChildren().length-1].dispose();
				}
				resizeBigViewCanvas();
			}
			Integer j = 0;
			BigViewModel referenceModel=null;
			for(Iterator i = sensors.iterator(); i.hasNext(); j++) {
				Sensor s = Activator.getDefault().getSensorForOscAddress((String)i.next());
				BigViewWithButtonsComposite b = ((BigViewWithButtonsComposite)bigViewParent.getChildren()[j]);
				b.getModel().setSensor(s);
				b.addOscAddressAsFilterOutput(s.getOSCAddress());
				b.getBigViewCanvas().setSensor(s);
				// make sure the new canvas inherits the current play/pause mode
				b.getModel().setPlaying(playing);
				//update zoom on all views in case we last looked at them with a different zoom level
				b.getModel().setZoom(zoomScale.getSelection());
				//copy the start and end time from the first sensor (the reference)
				//to all others.
				if(j==0) {
					referenceModel=b.getModel();
				} else {
					b.getModel().setStartTime(referenceModel.getStartTime());
					b.getModel().setEndTime(referenceModel.getEndTime());
				}
				b.refreshButtonState();

			}
			//synchronize drag/draw mode on all of canvases
			Activator.getDefault().pcs.firePropertyChange(ExemplarConstants.PROP_USER_MOUSE_TOOL, null, mouseMode);
			
			
		}
		else if(ExemplarConstants.PROP_MOUSE_DRAGGING.equals(evt.getPropertyName()))
		{
			//int delta;
			//if(lastMouseMoveEvent==null) {
			//	delta= getTimeOffsetForPixelOffset(lastMouseDownEvent.x-me.x);
			//} else {
			//	delta= getTimeOffsetForPixelOffset(lastMouseMoveEvent.x-me.x);
			//}
			//update model
			//BigViewModel model = ((BigViewWithButtonsComposite)getParent()).getModel();
			//model.setStartTime(model.getStartTime()+delta);
			//lastMouseMoveEvent=me;
			
			for(int i=0; i<bigViewParent.getChildren().length; i++) 
			{
				BigViewWithButtonsComposite b = (BigViewWithButtonsComposite)bigViewParent.getChildren()[i];
				BigViewModel model = b.getModel();
				int currentDelta = model.getEndTime()-model.getStartTime();
				model.setStartTime(Math.max(0, Math.min(model.getStartTime() + ((Integer) evt.getNewValue()),model.getBufferSize()-currentDelta)));
			}
			
		}
		//redraw slider
		else if(ExemplarConstants.PROP_REDRAW.equals(evt.getPropertyName())) {
			
				Display d = Activator.getDefault().getWorkbench().getDisplay();
				if(!d.isDisposed()) {
					try {
					Activator.getDefault().getWorkbench().getDisplay().asyncExec (new Runnable () {
						public void run () {
							if(!slider1.isDisposed()) {
								//make sure we're showing at least one signal before accessing its model
								if(bigViewParent.getChildren().length>=1) {
									//all signals should have idewntical values here, so we can pick any one
									BigViewModel model = ((BigViewWithButtonsComposite)bigViewParent.getChildren()[0]).getModel();
									if(playing) {
										slider1.setMaximum(model.getBufferSize());
										//TODO: incorrect math
										slider1.setThumb(Math.max(1,(int)((float)model.getDelta()/model.getBufferSize())));
									} else {
										slider1.setMaximum(pausedLength);
										slider1.setThumb(Math.max(1,(int)((float)model.getDelta()/pausedLength)));
									}
									slider1.setSelection(model.getStartTime());
								}
							}
						}
					});
					} catch (NullPointerException e) {
						//Display may disappear while shutting down
					}
				}
			}
		else if(ExemplarConstants.PROP_SHOW_USER_REGION.equals(evt.getPropertyName())) {
			pauseAndShowRegion((EventRegion)evt.getNewValue());
		}
	}
	
	private void pauseAndShowRegion(EventRegion region) {
		//
		BigViewWithButtonsComposite b=null;
		playing=false;
		playPauseBtn.setSelection(true);
		Activator.getDefault().pauseInput();
		pauseBgComposite.setBackground(SWTResourceManager.getColor(255, 128, 128));
		playPauseBtn.setText("Play");
		
		for(int i=0; i<bigViewParent.getChildren().length; i++) {
			b = (BigViewWithButtonsComposite)bigViewParent.getChildren()[i];
			b.getModel().setPlaying(playing);
			pausedLength = b.getModel().getBufferSize();
			int delta = region.getEndTime()-region.getStartTime();
			b.getModel().setStartTime(region.getStartTime()-delta);
			b.getModel().setEndTime(region.getEndTime()+delta);
			int zoom = b.getModel().computeZoom();
			zoomScale.setSelection(zoom);
			b.getBigViewCanvas().setActiveRegion(region);
		}
		
		slider1.setEnabled(!playing);
//		TODO: update zoom slider accordingly; update scrollbar accordingly;
	}

	private void playPauseBtnWidgetSelected(SelectionEvent evt) {
		//
		BigViewWithButtonsComposite b=null;
		playing=!playing;

		//pause or resume data gathering from sensors
		if(!playing) {
			Activator.getDefault().pauseInput();
			pauseBgComposite.setBackground(SWTResourceManager.getColor(255, 128, 128));
			playPauseBtn.setText("Play");
		}
		else {
			Activator.getDefault().resumeInput();
			pauseBgComposite.setBackground(SWTResourceManager.getColor(212, 208, 200));
			playPauseBtn.setText("Pause");
		}
		
		for(int i=0; i<bigViewParent.getChildren().length; i++) {
			b = (BigViewWithButtonsComposite)bigViewParent.getChildren()[i];
			b.getModel().setPlaying(playing);
			//if we are starting to play
			if(playing) {
				//Activator.getDefault().pcs.addPropertyChangeListener(ExemplarConstants.PROP_REDRAW,b.getBigViewCanvas());
				b.getModel().setEndTime(b.getModel().getBufferSize());
			} else {
				//don't unhook - we're having trouble with screen updates otherwise
				//Activator.getDefault().pcs.removePropertyChangeListener(ExemplarConstants.PROP_REDRAW,b.getBigViewCanvas());
				pausedLength = b.getModel().getBufferSize();
			}
		}
		if(b!=null) {
			slider1.setEnabled(!playing);
		}
	}
	
	private void slider1WidgetSelected(SelectionEvent evt) {
		BigViewWithButtonsComposite b=null;
		for(int i=0; i<bigViewParent.getChildren().length; i++) {
			b = (BigViewWithButtonsComposite)bigViewParent.getChildren()[i];
			b.getModel().setStartTime(slider1.getSelection());
			b.getBigViewCanvas().redraw();
		}
	}
	/*
	private void btnClearBufferWidgetSelected(SelectionEvent evt) {
		Activator.getDefault().clearAllSensorData();
	}
	*/

}